/*
 * Copyright 2009 Sergey Skladchikov
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.gwt.advanced.client.ui.widget.cell;

import com.google.gwt.user.client.ui.HasFocus;
import com.google.gwt.user.client.ui.KeyboardListenerAdapter;
import com.google.gwt.user.client.ui.Widget;

/**
 * This is a default keyboard listener for all cells.
 *
 * @author <a href="mailto:sskladchikov@gmail.com">Sergey Skladchikov</a>
 * @since 1.0.0
 */
public class CellKeyboardListener extends KeyboardListenerAdapter {
    /**
     * This method passivates the cell on enter key press.
     *
     * @param sender is a sender cell.
     * @param keyCode is a pressed key code.
     * @param modifiers is a modifiers mask.
     */
    public void onKeyPress (Widget sender, char keyCode, int modifiers) {
        if (keyCode == KEY_ENTER && sender instanceof HasFocus)
            ((HasFocus)sender).setFocus(false);
    }
}
