/*
 * Copyright 2009 Sergey Skladchikov
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.gwt.advanced.client.util;

/**
 * This is a CSS manipulation util.
 *
 * @author <a href="mailto:sskladchikov@gmail.com">Sergey Skladchikov</a>
 * @since 1.0.0
 */
public class StyleUtil {
    /**
     * This method sets a href attribute of the specified link element.
     *
     * @param linkElementId is a link element.
     * @param url is a URL to be applied for the href.
     */
    public static native void setLinkHref(String linkElementId, String url) /*-{
        var link = $doc.getElementById(linkElementId);
        if (link != null && link != undefined) {
            link.href = url;
        }
    }-*/;
}
