-- /*  
-- * Copyright (c) 2009 Ant Kutschera, maxant
-- * 
-- * This file is part of the maxant GWT Demo.
-- * 
-- * maxant GWT Demo is free software: you can redistribute it and/or modify
-- * it under the terms of the Lesser GNU General Public License as published by
-- * the Free Software Foundation, either version 3 of the License, or
-- * (at your option) any later version.
-- * 
-- * maxant GWT Demo is distributed in the hope that it will be useful,
-- * but WITHOUT ANY WARRANTY; without even the implied warranty of
-- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- * Lesser GNU General Public License for more details.
-- * You should have received a copy of the Lesser GNU General Public License
-- * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
-- */

use gwtdemo;
begin;

-- *****************************************************
-- *                                                   *
-- * populates the tables with test data               *
-- *                                                   *
-- *****************************************************


delete from design_comment;
delete from front_page_design;
delete from sales_order_item;
delete from sales_order;
delete from design_tag;
delete from design_rating;
delete from design;
delete from artist_view;
delete from role;
delete from party;
delete from config;

alter table sales_order_item auto_increment = 1;
alter table design auto_increment = 1;
alter table role auto_increment = 1;
alter table artist_view auto_increment = 1;
alter table config auto_increment = 1;
alter table design_comment auto_increment = 1;

alter table party auto_increment = 7516;
alter table design auto_increment = 5543;
alter table sales_order auto_increment = 397950;


insert into config values (null, 'paypal_payment_url', 'http://gwtdemomaxantcouk:8089/paypalStub/paypalStub1.jsp', 'The PayPal URL for making payments.', now());
insert into config values (null, 'paypal_merchant_email', 'someone@merchantdomain.com', 'The primary email address of the clients merchant account', now());
insert into config values (null, 'paypal_currency', 'GBP', 'See PayPal for options.', now());
insert into config values (null, 'paypalReturnURL', 'http://gwtdemomaxantcouk:8089/checkoutCompletePaypal.jsp', 'The URL to where PayPal should return after payment is complete.', now());
insert into config values (null, 'paypalCancelReturnURL', 'http://gwtdemomaxantcouk:8089/', 'The URL to where PayPal should return after payment is complete.', now());
insert into config values (null, 'paypalIPNURL', 'http://gwtdemomaxantcouk:8089/paypalipn.jsp', 'The URL to where PayPal should send IPN notifications.', now());
insert into config values (null, 'emailsFrom', 'noreply@merchantdomain.com', 'Email address from which mail is sent.', now());
insert into config values (null, 'emailOps', 'ops@merchantdomain.com', 'Email address to which operations requests are sent, eg order ready for picking.', now());
insert into config values (null, 'emailAdmin', 'admin@merchantdomain.com', 'Email address to which errors are sent.', now());
insert into config values (null, 'emailModerators', 'moderations@merchantdomain.com', 'Email address to which moderation requests are sent.', now());
insert into config values (null, 'emailOpsOnOrderPlaced', 'true', 'If true, then send an email to operations when orders are placed.', now());
insert into config values (null, 'emailOpsOnSuccessfulPayment', 'true', 'If true, then send an email to operations when payment is successful.', now());
insert into config values (null, 'emailOpsOnFailedPayment', 'true', 'If true, then send an email to operations when payment has failed.', now());
insert into config values (null, 'emailOpsOnMarkOrderAsNeedingAttention', 'true', 'If true, then send an email to operations when an order is marked as needing attention.', now());
insert into config values (null, 'emailOpsOnOrderPlacement', 'true', 'If true, then send an email to operations when an order is placed (ie return from paypal', now());
insert into config values (null, 'registrationForceConfirm', 'true', 'If true, then user must confirm their registration', now());
insert into config values (null, 'emailFooter', '<hr>Your GWTDemo Team<br>5 Someplace, Sometown, Oz<br>http://gwtdemo.maxant.co.uk<br>+91 (0) 283 4837383<br>support@merchantdomain.com<br>some legal stuff, copyright, etc...', 'email footer, html', now());
insert into config values (null, 'designCommentModerationRequired', 'true', 'if true, then only moderated comments are shown', now());
insert into config values (null, 'designCommentModerationSendEmailToModerator', 'true', 'if true, AND designCommentModerationRequired then send emails when new comments are added', now());
insert into config values (null, 'httpUrl', 'http://gwtdemomaxantcouk:8089', 'the url to the site', now());
insert into config values (null, 'httpsUrl', 'https://gwtdemomaxantcouk:8443', 'the secure url to the site', now());
insert into config values (null, 'siteName', 'maxant GWTDemo', 'the name of the site', now());

insert into party values (null, 'andy@maxant.co.uk', 'asdf', 'antipasti', 'Andy', 
	'Kaye', 'Dr', now(), now(), '078 643 5464', '', true, false, 'Google', false, 'AFDD', true, false, 
	'Andy is an artist but knows nowt about art.', null, 'EN', '', '', '');
insert into party values (null, 'jay@maxant.co.uk', 'asdf', 'xjay', 'Jay', 
	'Roberts', 'Mr', now(), now(), '078 643 5465', '', true, false, 'Yahoo', true, 'AFDE', true, false, 
	'Some blah blah about Jay. Te quo voluptatum intellegebat, cu elit suavitate salutatus mei. His no dolorum detraxit expetendis, odio admodum vulputate cu mei. Gloriatur appellantur repudiandae eu est, usu vocent fierent scripserit te, dicam dictas eu pro.', null, 'EN', '', '', '');
insert into party values (null, 'john@maxant.co.uk', 'asdf', 'johnny', 'John', 
	'Smith', 'Mr', now(), now(), '078 643 5466', '', true, false, 'Google', true, 'AFDF', false, false, null, null, 'EN', '', '', '');
insert into party values (null, 'alex@maxant.co.uk', 'asdf', 'alexi', 'Alex', 
	'Simpson', 'Mr', now(), now(), '078 643 5467', '', true, false, 'Google', true, 'AFDG', false, false, null, null, 'EN', '', '', '');

insert into role values (null, 'andy@maxant.co.uk', 'artist');
insert into role values (null, 'andy@maxant.co.uk', 'registered');
insert into role values (null, 'jay@maxant.co.uk', 'artist');
insert into role values (null, 'jay@maxant.co.uk', 'backoffice');
insert into role values (null, 'jay@maxant.co.uk', 'picking');
insert into role values (null, 'jay@maxant.co.uk', 'registered');
insert into role values (null, 'john@maxant.co.uk', 'picking');
insert into role values (null, 'john@maxant.co.uk', 'registered');
insert into role values (null, 'alex@maxant.co.uk', 'backoffice');
insert into role values (null, 'alex@maxant.co.uk', 'superAdmin');
insert into role values (null, 'alex@maxant.co.uk', 'picking');
insert into role values (null, 'alex@maxant.co.uk', 'designCommentsModerator');
insert into role values (null, 'alex@maxant.co.uk', 'registered');

insert into design values (null, true, true, 'aReallyLongNameWithNoWhiteSpaceForTestingPurposes', 'A freezing design made from some ice crystals that were frozen using nitrogen purely to get a longer description here...', 7516, 0, 0, 0.0, now());
insert into design values (null, true, true, 'a really long name with no white space for testing', 'A freezing design', 7516, 0, 0, 0.5, now());
insert into design values (null, true, true, 'Cold Blue', 'A cold design', 7516, 0, 0, 1.0, now());
insert into design values (null, true, true, 'Cold Blue', 'A nice design', 7516, 0, 0, 0.25, now());

insert into design values (null, true, true, 'Warm Orange', 'A hot hot design', 7516, 0, 0, 0.40, now());
insert into design values (null, true, true, 'Warm Orange', 'A hot cold design', 7516, 0, 0, 3.00, now());
insert into design values (null, true, true, 'Warm Orange', 'A cold hot design', 7516, 0, 0, 5.05, now());
insert into design values (null, true, true, 'Warm Orange', 'A hot dry design', 7516, 0, 0, 9.99, now());

insert into design values (null, true, true, 'North', 'Its not upside down! Erm...', 7517, 0, 0, 0.99, now());

insert into design_tag values (null, 5543, 'Winter');
insert into design_tag values (null, 5543, 'Cold');
insert into design_tag values (null, 5543, 'Ice');
insert into design_tag values (null, 5546, 'Hot');
insert into design_tag values (null, 5551, 'Southerly');

-- create 7 featured designs. pages shows random 6.
insert into front_page_design values (null, 5543);
insert into front_page_design values (null, 5544);
insert into front_page_design values (null, 5545);
insert into front_page_design values (null, 5546);
insert into front_page_design values (null, 5547);
insert into front_page_design values (null, 5549);
insert into front_page_design values (null, 5551);

insert into design_comment values (null, now(), null, null, 
		'Suas summo doctus vim no. Mea ea quem eros saepe, ei nec oratio verear iuvaret, kasd dicunt ex nec. \
Cu vel augue sonet veritus, an paulo ponderum luptatum eam, an per quodsi animal corrumpit. Sea no persius \
phaedrum singulis, vidisse corrumpit ex cum.', 5544, 7516, null);

insert into design_comment values (null, now(), now(), null, 
		'Suas summo doctus vim no. Mea ea quem eros saepe, ei nec oratio verear iuvaret, kasd dicunt ex nec. \
Cu vel augue sonet veritus, an paulo ponderum luptatum eam, an per quodsi animal corrumpit. Sea no persius \
phaedrum singulis, vidisse corrumpit ex cum.', 5544, 7516, 7519);


insert into design_comment values (null, now(), null, now(), 
		'Suas summo doctus vim no. Mea ea quem eros saepe, ei nec oratio verear iuvaret, kasd dicunt ex nec. \
Cu vel augue sonet veritus, an paulo ponderum luptatum eam, an per quodsi animal corrumpit. Sea no persius \
phaedrum singulis, vidisse corrumpit ex cum.', 5544, 7516, 7519);

commit;


