/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.artist_admin.core;

import uk.co.maxant.gwtdemo.client.to.Artist;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

public class ArtistAdminController {

	protected IArtistAdmin view;
	protected ArtistAdminServerCaller serverCaller;
	protected ArtistAdminModel model;
	
	public ArtistAdminController(IArtistAdmin view, AppWizard wizard){
		this.view = view;
		this.model = new ArtistAdminModel();
		this.serverCaller = new ArtistAdminServerCaller(view, model, wizard);
	}
	
	/**
	 * causes the relevant Artists to be loaded.
	 * @param filter filter to be used in selecting relevant Artists
	 */
	public void setArtists(String filter) {
		serverCaller.getArtists(filter);
	}

	public ArtistAdminModel getModel() {
		return model;
	}

	/**
	 * updates the given Artist and refreshes the page contents with the given filter.
	 */
	public void updateArtist(Artist a, 
							String newTitle, 
							String newEmail, 
							String newScreenname, 
							String newFirstName, 
							String newLastName, 
							String newDescription, 
							String newNotes,
							String filter) {

		a.setTitle(newTitle);
		a.setEmail(newEmail);
		a.setScreenname(newScreenname);
		a.setFirstname(newFirstName);
		a.setLastname(newLastName);
		a.setDescription(newDescription);
		a.setNotes(newNotes);
		
		serverCaller.updateArtist(a, filter);
	}

}
