/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.artistprofile.core;

import uk.co.maxant.gwtdemo.client.to.Artist;
import uk.co.maxant.gwtdemo.client.to.Design;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

public class ArtistProfileController {

	protected IArtistProfile view;
	protected ArtistProfileServerCaller serverCaller;
	protected ArtistProfileModel model;
	
	public ArtistProfileController(IArtistProfile view, AppWizard wizard){
		this.view = view;
		this.model = new ArtistProfileModel();
		this.serverCaller = new ArtistProfileServerCaller(view, model, wizard);
	}
	
	/**
	 * method to get profile
	 */
	public void getProfile() {
		serverCaller.getUser();
	}

	public ArtistProfileModel getModel() {
		return model;
	} 
	
	public void update(Artist artist) {
		serverCaller.update(artist);
	}

	public void createNewDesign(Design d) {
		serverCaller.addDesign(d);
	}

	public void showDesignInShop(Design d) {
		serverCaller.showDisplayableInShop(model.getArtist(), d.getUid(), true); //show non-purcheasable content too, as we are an artist
	}

	public void setNewDesignId(Integer newDesignId) {
		model.setNewDesignId(newDesignId);
	}

}
