/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.checkout.core;

import uk.co.maxant.gwtdemo.client.ApplicationLayerService;
import uk.co.maxant.gwtdemo.client.util.AsyncCallbackImpl;
import uk.co.maxant.gwtdemo.client.widgets.core.WizardServerCaller;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

import com.google.gwt.user.client.rpc.AsyncCallback;

/**
 * delegated to by controller
 */
public class CheckoutServerCaller extends WizardServerCaller {

	private ICheckout checkout;
	private CheckoutModel model;
	
	public CheckoutServerCaller(ICheckout checkout, CheckoutModel model, AppWizard wizard){
		super(wizard, checkout);
		this.checkout = checkout;
		this.model = model;
	}
	
	/**
	 * call this to update the basket in the checkout screen.
	 * 
	 * @see ApplicationLayerService#getBasket()
	 */
	public void getBasketForCheckout() {
		getBasket();
	}
	
	/**
	 * @see ApplicationLayerService#createOrder(Address)
	 */
	public void createOrder(String email, String name) {
		AsyncCallback<Integer> callback = new AsyncCallbackImpl<Integer>(this) {
			
			public void onSuccess_(Integer orderUid) {
				checkout.orderCreated(orderUid);
			}
		};
		callServer();
		getServiceClient().createOrder(email, name, callback);
	}
	
}

