package uk.co.maxant.gwtdemo.client.checkout.core;

import uk.co.maxant.gwtdemo.client.widgets.core.ModelListener;
import uk.co.maxant.gwtdemo.client.widgets.core.Waitable;

/**
 * technology independent interface for the checkout screen. the controller only knows about this interface
 * so that the actual page could be swing, RCP or GWT.
 */
public interface ICheckout extends ModelListener, Waitable {

	/**
	 * callback for when a new order has been completed.
	 * 
	 * @param orderUid the order id of the newly persisted order.
	 */
	void orderCreated(Integer orderUid);

}
