/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.design_admin.core;

import com.google.gwt.user.client.ui.UIObject;

import uk.co.maxant.gwtdemo.client.generic.widgets.FilterBox.FilterableUIObject;
import uk.co.maxant.gwtdemo.client.to.Design;

public class DesignFilterableUIObject extends FilterableUIObject {
	
	private Design design;
	
	public DesignFilterableUIObject(UIObject uiObject, Design design){
		super(uiObject);
		this.design = design;
	}
	
	@Override
	public String[] getTagsToCompare() {
		String[] selectables = new String[7 + design.getTags().size()];
		int i = 0;
		selectables[i++] = String.valueOf(design.getUid());
		selectables[i++] = design.getName();
		selectables[i++] = design.getDescription();
		selectables[i++] = design.getArtist().getScreenname();
		selectables[i++] = design.getArtist().getFirstname();
		selectables[i++] = design.getArtist().getLastname();
		selectables[i++] = String.valueOf(design.getArtist().getUid());
		for(String tag : design.getTags()){
			selectables[i++] = tag;
		}
		return selectables;
	}
}
