/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.design_artist_list.core;

import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

public class DesignArtistListController {

	protected IDesignArtistList view;
	protected DesignArtistListServerCaller serverCaller;
	protected DesignArtistListModel model;
	
	public DesignArtistListController(IDesignArtistList view, AppWizard wizard){
		this.view = view;
		this.model = new DesignArtistListModel();
		this.serverCaller = new DesignArtistListServerCaller(view, model, wizard);
	}
	
	/**
	 * causes the relevant designs to be loaded.
	 * @param filter filter to be used in selecting relevant designs
	 */
	public void setDesigns() {
		serverCaller.getDesigns();
	}

	public DesignArtistListModel getModel() {
		return model;
	}

}
