/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.design_artist_list.core;


import java.util.List;

import uk.co.maxant.gwtdemo.client.to.Design;
import uk.co.maxant.gwtdemo.client.util.AsyncCallbackImpl;
import uk.co.maxant.gwtdemo.client.widgets.core.WizardServerCaller;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

import com.google.gwt.user.client.rpc.AsyncCallback;

/**
 * delegated to by controller
 */
public class DesignArtistListServerCaller extends WizardServerCaller {

	private IDesignArtistList designArtistList;
	private DesignArtistListModel model;
	
	public DesignArtistListServerCaller(IDesignArtistList designArtistList, DesignArtistListModel model, AppWizard wizard){
		super(wizard, designArtistList);
		this.designArtistList = designArtistList;
		this.model = model;
	}
	
	/**
	 * called to set the designs
	 * 
	 * @param filter the filter to use
	 */
	public void getDesigns() {
		
		AsyncCallback<List<Design>> callback = new AsyncCallbackImpl<List<Design>>(this) {
			
			public void onSuccess_(List<Design> designs) {
				model.setDesigns(designs);
				designArtistList.setDesigns();
			}
		};
		callServer();
		getServiceClient().getDesignsAdminLight(callback);
	}

}

