/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.generic.widgets;

import com.google.gwt.event.dom.client.BlurEvent;
import com.google.gwt.event.dom.client.BlurHandler;
import com.google.gwt.event.dom.client.ChangeEvent;
import com.google.gwt.event.dom.client.ChangeHandler;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.DomEvent;
import com.google.gwt.event.dom.client.FocusEvent;
import com.google.gwt.event.dom.client.FocusHandler;
import com.google.gwt.event.dom.client.KeyDownEvent;
import com.google.gwt.event.dom.client.KeyDownHandler;
import com.google.gwt.event.dom.client.KeyPressEvent;
import com.google.gwt.event.dom.client.KeyPressHandler;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.event.logical.shared.ValueChangeEvent;
import com.google.gwt.event.logical.shared.ValueChangeHandler;
import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;

/**
 * implements a shit load of handlers. all events lead to a call to {@link #onEvent(DomEvent)}.
 */
public abstract class Handler implements KeyPressHandler, KeyUpHandler, KeyDownHandler,
		ChangeHandler, BlurHandler, FocusHandler, ValueChangeHandler<String>, ClickHandler {

	public void onKeyPress(KeyPressEvent event) {
		onEvent(event);
	}

	public void onKeyUp(KeyUpEvent event) {
		onEvent(event);
	}

	public void onKeyDown(KeyDownEvent event) {
		onEvent(event);
	}

	public void onChange(ChangeEvent event) {
		onEvent(event);
	}

	public void onBlur(BlurEvent event) {
		onEvent(event);
	}

	public void onFocus(FocusEvent event) {
		onEvent(event);
	}

	public void onValueChange(ValueChangeEvent<String> event) {
		onEvent(event);
	}

	public void onClick(ClickEvent event) {
		onEvent(event);
	}
	
	/**
	 * override this to handle all events!
	 * @param event
	 */
	public abstract void onEvent(GwtEvent<? extends EventHandler> event);
}
