/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.generic.widgets;

/**
 * a screen wizard has the ability to flip between pages.
 * 
 * @see WizardPage
 */
public interface IWizard {

	/**
	 * shows the first page
	 */
	void showFirstPage();
	
	/**
	 * shows the next screen
	 */
	void showNextPage();
	
	/**
	 * shows the previous screen
	 */
	void showPreviousPage();

	/**
	 * show and activate the given page
	 * 
	 * @param page the page to show
	 */
	void showPage(WizardPage page);
	
}
