/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.generic.widgets;


import uk.co.maxant.gwtdemo.client.images.Images;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.HorizontalPanel;

public class QuestionDialog extends Dialog {
	
	public QuestionDialog(String title, String message, final Callback callback) {
		super(title, message);

		HorizontalPanel hp = UIFactory.createHorizontalPanel();
		
		Button yes = UIFactory.createButton("Yes");
		yes.addClickHandler(new ClickHandler(){
			public void onClick(ClickEvent event) {
	            hide();
	            callback.onClose(true);
			}
		});
		hp.add(yes);
		
		Button no = UIFactory.createButton("No");
		no.addClickHandler(new ClickHandler(){
			public void onClick(ClickEvent event) {
				hide();
				callback.onClose(false);
			}
		});
		hp.add(no);

		table.setWidget(1, 0, hp);
		
		setImage(Images.images.icon_question().createImage());
		
		setDefaultButton(yes);
	}

	public static interface Callback {
		void onClose(boolean yesClicked);
	}
	

}
