/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.generic.widgets;

import com.google.gwt.user.client.ui.Composite;

/**
 * common class for all screens within a wizard.
 * 
 * @see IWizard
 */
public abstract class WizardPage extends Composite {

	private IWizard wizard;
	
	private boolean active = false;

	/**
	 * @return is the current page active and on display?
	 */
	public boolean isActive() {
		return active;
	}

	/**
	 * @param wizard the parent wizard
	 */
	public WizardPage(IWizard wizard) {
		this.wizard = wizard;
	}
	
	/**
	 * called when this screen is activated
	 */
	protected void activated(){
	}
	
	/**
	 * called when this screen is deactivated
	 */
	protected void deactivated(){
	}

	/**
	 * called when another screen is activated.
	 */
	protected final void deactivated_(){
		active = false;
		deactivated();
	}
	
	/**
	 * imperative that the implementation class calls this to 
	 */
	protected final void activated_(){
		active = true;
		activated();
	}

	public IWizard getWizard() {
		return wizard;
	}

}
