/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.home.core;

import uk.co.maxant.gwtdemo.client.to.Artist;
import uk.co.maxant.gwtdemo.client.to.Design;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

public class HomeController {

	protected IHome view;
	protected HomeServerCaller serverCaller;
	protected HomeModel model;
	
	public HomeController(IHome view, AppWizard wizard){
		this.view = view;
		this.model = new HomeModel();
		this.serverCaller = new HomeServerCaller(view, model, wizard);
	}
	
	
	/**
	 * method for getting the featured designs from server.
	 */
	public void getFeaturedDesigns() {
		serverCaller.getFeaturedDesigns();
	}

	/**
	 * shows the design in the shop
	 */
	public void showDesignInShop(Design d) {
		serverCaller.showDisplayableInShop(d.getArtist(), d.getUid());
	}

	/**
	 * shows the given artist in the show, preselecting its first design
	 */
	public void showArtistInShop(Artist a) {
		serverCaller.showDisplayableInShop(a, null);
	}
	
	/**
	 * loads cloud from server
	 */
	public void getCloud() {
		serverCaller.getCloud();
	}

	/**
	 * method for getting the newest designs from server.
	 */
	public void getNewestDesigns() {
		serverCaller.getNewestDesigns();
	}

}
