/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.home.core;

import java.util.List;

import uk.co.maxant.gwtdemo.client.to.Artist;
import uk.co.maxant.gwtdemo.client.to.Design;
import uk.co.maxant.gwtdemo.client.widgets.core.Waitable;

/**
 * technology independent interface for the home screen. the controller only knows about this interface
 * so that the actual home page could be swing, RCP or GWT.
 */
public interface IHome extends Waitable {

	/**
	 * @param designs the list of featured designs to display in the home screen.
	 */
	void setFeaturedDesigns(List<Design> designs);

	/**
	 * @param designs the list of newest designs to display in the home screen.
	 */
	void setNewestDesigns(List<Design> designs);

	/**
	 * called by the serverCaller when server call completes, and draws the cloud
	 */
	void setCloud(List<Artist> artists);

	/**
	 * called if any timer server calls fail.
	 */
	void cancelTimers();

}
