/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.order_admin_list.ui;


import uk.co.maxant.gwtdemo.client.order_admin_list.core.OrdersListController.SEARCH_TYPE;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

/**
 * the order screen, which lets customers manage their orders.
 */
public class OrdersCustomerList extends OrdersAdminList {

	/**
	 */
	public OrdersCustomerList(final AppWizard wizard){
		super(wizard, false);
	}
	
	protected String getDescription() {
		return "Customers can view all of their orders using this page. Pending as well as dispatched / delivered orders are displayed in reverse chronological order below. Use the filter to search for individual orders. Click on any row to view the details of that order.";
	}

	@Override
	public void activated(){
		controller.setSalesOrders(SEARCH_TYPE.CUSTOMER);
	}

}
