/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.order_admin_list.ui;


import uk.co.maxant.gwtdemo.client.order_admin_list.core.OrdersListController.SEARCH_TYPE;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

/**
 * the order admin screen, which lets admin view discarded orders.
 */
public class OrdersDiscardedAdminList extends OrdersAdminList {

	/**
	 */
	public OrdersDiscardedAdminList(final AppWizard wizard){
		super(wizard, false);
	}
	
	@Override
	protected String getDescription() {
		return "Administrators can view sales orders that have been discarded (ie. when the cart is not " +
				"purchased and the session is discarded." +
				"<br><br>" +
				"This gives admin an idea of products which are not being sold, although they are still tempting. " +
				"Such items are idea for sales / offers / discounts.";
	}
	
	@Override
	public void activated(){
		controller.setSalesOrders(SEARCH_TYPE.ADMIN_DISCARDED);
	}

}
