/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.order_admin_list.ui;

import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

/**
 * the order admin screen, which lets admin manage ALL orders.
 */
public class OrdersSearchAdminList extends OrdersAdminList {

	/**
	 */
	public OrdersSearchAdminList(final AppWizard wizard){
		super(wizard, true);
	}
	
	protected String getDescription() {
		return "Administrators can search for sales orders. The search checks the following attributes:" +
				"<ul>" +
				"	<li>Customer ID</li>" +
				"	<li>Customer Email</li>" +
				"	<li>Customer First Name</li>" +
				"	<li>Customer Last Name</li>" +
				"	<li>Screen Name (if the customer is an artist)</li>" +
				"	<li>Customer's Notes</li>" +
				//"	<li>Picker (Staff) ID</li>" +
				//"	<li>Picker First Name</li>" +
				//"	<li>Picker Last Name</li>" +
				"	<li>Order Email (if it's different from the customer's normal email)</li>" +
				"	<li>Delivery Address ZIP</li>" +
				"	<li>History</li>" +
				"	<li>Transaction ID (from payment system)</li>" +
				"</ul>" +
				"Click on a row to view/update the orders details.";
	}

	@Override
	public void activated(){
	}
	
}
