/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.order_complete.core;

import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

/**
 * controller for OrderComplete page, which redirects to paypal
 */
public class OrderCompleteController {

	protected IOrderComplete view;
	private OrderCompleteServerCaller serverCaller;
	private OrderCompleteModel model;
	
	public OrderCompleteController(IOrderComplete view, AppWizard wizard){
		this.view = view;
		this.model = new OrderCompleteModel();
		this.serverCaller = new OrderCompleteServerCaller(view, model, wizard);
	}
	
	/**
	 * causes the browser to redirect to paypal by loading the config and calling the view to do the
	 * redirect.
	 * 
	 * @param soUid the order UID to use when getting the paypal config or redirecting to paypal for payment.
	 */
	public void redirectToPaypal(Integer soUid){
		serverCaller.getPaypalConfig(soUid);
	}
	
}
