/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.order_complete.core;

import com.google.gwt.user.client.rpc.AsyncCallback;

import uk.co.maxant.gwtdemo.client.ApplicationLayerService;
import uk.co.maxant.gwtdemo.client.to.PaypalConfig;
import uk.co.maxant.gwtdemo.client.util.AsyncCallbackImpl;
import uk.co.maxant.gwtdemo.client.widgets.core.WizardServerCaller;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

/**
 * delegated to by controller
 */
public class OrderCompleteServerCaller extends WizardServerCaller {

	private IOrderComplete orderComplete;
	private OrderCompleteModel model;
	
	public OrderCompleteServerCaller(IOrderComplete orderComplete, OrderCompleteModel model, AppWizard wizard){
		super(wizard, orderComplete);
		this.orderComplete = orderComplete;
		this.model = model;
	}
	
	/**
	 * @see ApplicationLayerService#getPaypalConfig(Integer)
	 */
	public void getPaypalConfig(Integer soUid) {
		AsyncCallback<PaypalConfig> callback = new AsyncCallbackImpl<PaypalConfig>(this) {
			
			public void onSuccess_(PaypalConfig config) {
				orderComplete.configLoaded(config);
			}
		};
		callServer();
		getServiceClient().getPaypalConfig(soUid, callback);
	}

}

