/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.order_detail.core;

import uk.co.maxant.gwtdemo.client.to.OrderState;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

public class OrderAdminDetailController extends AbstractOrderDetailController {

	protected IOrderAdminDetail view;
	
	public OrderAdminDetailController(IOrderAdminDetail view, AppWizard wizard){
		this.view = view;
		this.serverCaller = new OrderAdminDetailServerCaller(view, model, wizard);
	}
	
	/**
	 * @param requiredState not null
	 * @param extraNotes may be null if not a payment status
	 * @param txnId may be null if not a payment status
	 */
	public void updateOrderStatus(OrderState requiredState, String notes){
		((OrderAdminDetailServerCaller)serverCaller).updateOrderStatus(requiredState, model.getSalesOrder().getUid(), notes);
	}

	/**
	 * called to update the sales order
	 */
	public void updatePaymentStatus(OrderState requiredState, String extraNotes, String txnId){
		((OrderAdminDetailServerCaller)serverCaller).updatePaymentStatus(requiredState, model.getSalesOrder().getUid(), extraNotes, txnId);
	}

	/**
	 * called to update the sales order
	 */
	public void addShopNotes(String notes) {
		((OrderAdminDetailServerCaller)serverCaller).addShopNotes(model.getSalesOrder().getUid(), notes);
	}
	
	/**
	 * called to update the sales order
	 */
	public void markOrderAsNeedingAttention(String notes) {
		((OrderAdminDetailServerCaller)serverCaller).markOrderAsNeedingAttention(model.getSalesOrder().getUid(), notes);
	}
	
	/**
	 * called to update the sales order
	 */
	public void markOrderAsNotNeedingAttention(String notes) {
		((OrderAdminDetailServerCaller)serverCaller).markOrderAsNotNeedingAttention(model.getSalesOrder().getUid(), notes);
	}
	
}
