/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.order_detail.ui;


import uk.co.maxant.gwtdemo.client.generic.widgets.AbstractInputDialog;
import uk.co.maxant.gwtdemo.client.generic.widgets.UIFactory;

import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;

public class PaymentStatusChangedInputDialog extends AbstractInputDialog<PaymentStatusChangedInputDialog.Result> {
	
	protected TextArea input;
	protected TextBox txnId;
	
	public PaymentStatusChangedInputDialog(final Callback<Result> callback) {
		super("Payment Information", "Please enter the details below:", 
				"Please enter a comment.", callback);
	}
	
	protected com.google.gwt.user.client.ui.Widget createContents() {
		VerticalPanel vp = UIFactory.createVerticalPanel();
		HorizontalPanel hp = UIFactory.createHorizontalPanel();
		HTML lbl = UIFactory.createHTML("Comment:");
		hp.add(lbl);
		input = UIFactory.createTextArea();
		input.setPixelSize(300, 200);
		hp.add(input);
		vp.add(hp);
		hp = UIFactory.createHorizontalPanel();
		lbl = UIFactory.createHTML("Transaction ID:");
		hp.add(lbl);
		txnId = UIFactory.createTextBox();
		hp.add(txnId);
		vp.add(hp);
		return vp;
	}

	protected boolean validate(){
		if(input.getText().length() > 0){
			data = new Result(txnId.getText(), input.getText());
			return true;
		}
		return false;
	}
	
	@Override
	protected void doInvalid() {
		input.selectAll();
	}

	public static class Result {
		public String txnId;
		public String comment;
		public Result(String txnId, String comment){
			this.txnId = txnId;
			this.comment = comment;
		}
	}
}
