/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.profile.core;

import uk.co.maxant.gwtdemo.client.to.User;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

public class ProfileController {

	protected IProfile view;
	protected ProfileServerCaller serverCaller;
	protected ProfileModel model;
	
	public ProfileController(IProfile view, AppWizard wizard){
		this.view = view;
		this.model = new ProfileModel();
		this.serverCaller = new ProfileServerCaller(view, model, wizard);
	}
	
	/**
	 * method to get profile
	 */
	public void getProfile() {
		serverCaller.getUser();
	}

	public ProfileModel getModel() {
		return model;
	} 
	
	public void update(User user, String newPassword) {
		serverCaller.update(user, newPassword);
	}
	
}
