/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.profile.core;

import uk.co.maxant.gwtdemo.client.ApplicationLayerService;
import uk.co.maxant.gwtdemo.client.to.Artist;
import uk.co.maxant.gwtdemo.client.to.User;
import uk.co.maxant.gwtdemo.client.util.AsyncCallbackImpl;
import uk.co.maxant.gwtdemo.client.widgets.core.WizardServerCaller;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

import com.google.gwt.user.client.rpc.AsyncCallback;

/**
 * delegated to by controller
 */
public class ProfileServerCaller extends WizardServerCaller {

	private IProfile profile;
	private ProfileModel model;
	
	public ProfileServerCaller(IProfile profile, ProfileModel model, AppWizard wizard){
		super(wizard, profile);
		this.profile = profile;
		this.model = model;
	}
	
	/**
	 * @see ApplicationLayerService#getLoggedInArtist()
	 */
	public void getUser() {
		AsyncCallback<Artist> callback = new AsyncCallbackImpl<Artist>(this) {
			public void onSuccess_(Artist a) {
				model.setArtist(a);
				profile.setArtist(a);
			}
		};
		callServer();
		getServiceClient().getLoggedInArtist(callback);
	}

	public void update(User user, String newPassword) {
		AsyncCallback<Integer> callback = new AsyncCallbackImpl<Integer>(this) {
			public void onSuccess_(Integer uid) {
				profile.userUpdated();
			}
		};
		callServer();
		getServiceClient().updateCustomer(user, newPassword, callback);
	}
	
}

