/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.register.core;

import uk.co.maxant.gwtdemo.client.to.User;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

public class RegisterController {

	protected IRegister view;
	protected RegisterServerCaller serverCaller;
	protected RegisterModel model;
	
	public RegisterController(IRegister view, AppWizard wizard){
		this.view = view;
		this.model = new RegisterModel();
		this.serverCaller = new RegisterServerCaller(view, model, wizard);
	}
	
	
	/**
	 * method to register
	 */
	public void register(User user, String password, String captcha, boolean alsoArtist, String artistsDescription) {
		serverCaller.registerUser(user, password, captcha, alsoArtist, artistsDescription);
	}

}
