/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.register.core;

import uk.co.maxant.gwtdemo.client.ApplicationLayerService;
import uk.co.maxant.gwtdemo.client.to.User;
import uk.co.maxant.gwtdemo.client.util.AsyncCallbackImpl;
import uk.co.maxant.gwtdemo.client.widgets.core.WizardServerCaller;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

import com.google.gwt.user.client.rpc.AsyncCallback;

/**
 * delegated to by controller
 */
public class RegisterServerCaller extends WizardServerCaller {

	private IRegister register;
	private RegisterModel model;
	
	public RegisterServerCaller(IRegister register, RegisterModel model, AppWizard wizard){
		super(wizard, register);
		this.register = register;
		this.model = model;
	}
	
	/**
	 * @see ApplicationLayerService#registerCustomerOrArtist(User, String, String, boolean, String)
	 */
	public void registerUser(User user, String password, String captcha, boolean alsoArtist, String artistsDescription) {
		AsyncCallback<Integer> callback = new AsyncCallbackImpl<Integer>(this) {
			@Override
			protected void onFailurePost(Throwable caught) {
				register.failedToRegisterUser();
			}

			public void onSuccess_(Integer uid) {
				register.userRegistered(uid);
			}
		};
		callServer();
		getServiceClient().registerCustomerOrArtist(user, password, captcha, alsoArtist, artistsDescription, callback);
	}
	
}

