/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.shop.ui;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.http.client.URL;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.HorizontalPanel;

import uk.co.maxant.gwtdemo.client.generic.widgets.UIFactory;
import uk.co.maxant.gwtdemo.client.images.Images;
import uk.co.maxant.gwtdemo.client.to.Design;

/**
 * adds little icons for sharing on social networks
 */
public class SocialNetworkHelper {

	private SocialNetworkHelper(){}
	
	public static void addLinks(final Design d, HorizontalPanel hp){
		String link = Window.Location.getProtocol() + "//";
		link += Window.Location.getHost() + "/index.jsp?designID=" + d.getUid();
		final String linkWithID = URL.encode(link);
		
		final String title = URL.encode(
					d.getName() + " by " + d.getArtist().getScreenname() + 
					" - available at " + Window.Location.getHost());

		/****************************
		 * facebook
		 * 
		 * http://www.facebook.com/share.php?u=
		 * 						http%3A%2F%2Fwww.starticket.ch%2F0ShowInfo.asp%3FShowID%3D29649%26ShowDetails%3D1
		 */
		com.google.gwt.user.client.ui.Image fb = UIFactory.createImageButton(Images.images.facebook().createImage());
		fb.setTitle("Share on Facebook");
		fb.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				//TODO 000 test this
				String url = "http://www.facebook.com/sharer.php?u=" + linkWithID + 
					"&t=" + title;
				String features = "menubar=no, status=no, titlebar=no, toolbar=no";
				Window.open(url, "_blank", features);
			}
		});
		hp.add(fb);

		/****************************
		 * twitter
		 * 
		 * http://twitter.com/home?status=
		 * 				Go%20to:+Alex+Gopher+
		 * 		%28FR%29+%2B+Punks+Jump+Up+%28UK%29+%2B+Dan+%28Digitales+
		 * 		Natives%29+Rocking+Chair+http%3A%2F%2Fwww.starticket.ch%2F0ShowInfo.
		 * 		asp%3FShowID%3D29649%26ShowDetails%3D1
		 */
		com.google.gwt.user.client.ui.Image tw = UIFactory.createImageButton(Images.images.twitter().createImage());
		tw.setTitle("Share on Twitter");
		tw.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				//TODO 000 test this
				String url = "http://twitter.com/home?status=" + title;
				String features = "menubar=no, status=no, titlebar=no, toolbar=no";
				Window.open(url, "_blank", features);
			}
		});
		hp.add(tw);

		/****************************
		 * google bookmark
		 * 
		 * http://www.google.com/bookmarks/mark?op=add&bkmk=
		 * 									http%3A%2F%2Fwww.starticket.ch%2F0ShowInfo.asp%3FShowID%3D29649%26ShowDetails%3D1
		 * 		&title=Alex+Gopher+%28FR%29+%2B+Punks+Jump+Up+%28UK%29+%2B+Dan+%28Digitales+Natives%29+Rocking+Chair+%2Astarticket
		 */
		com.google.gwt.user.client.ui.Image google = UIFactory.createImageButton(Images.images.google().createImage());
		google.setTitle("Google Bookmark");
		google.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				//TODO 000 test this
				String url = "http://www.google.com/bookmarks/mark?op=add&bkmk=" + linkWithID +
					"&title=" + title;
				String features = "menubar=no, status=no, titlebar=no, toolbar=no";
				Window.open(url, "_blank", features);
			}
		});
		hp.add(google);
		
		/****************************
		 * digg
		 * 
		 * http://digg.com/submit?phase=2&url=
		 * 				http%3A%2F%2Fwww.starticket.ch%2F0ShowInfo.asp%3F
		 * 					ShowID%3D29649%26ShowDetails%3D1
		 * 		&title=Alex+Gopher+%28FR%29+%2B+Punks+
		 * 			Jump+Up+%28UK%29+%2B+Dan+%28Digitales+Natives%29+Rocking+Chair+%2Astarticket
		 */
		com.google.gwt.user.client.ui.Image digg = UIFactory.createImageButton(Images.images.digger().createImage());
		digg.setTitle("Share on Digg");
		digg.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				//TODO 000 test this
				String url = "http://digg.com/submit?phase=2&url=" + linkWithID +
					"&title=" + title;
				String features = "menubar=no, status=no, titlebar=no, toolbar=no";
				Window.open(url, "_blank", features);
			}
		});
		hp.add(digg);

		/****************************
		 * myspace
		 * 
		 * http://www.myspace.com/Modules/PostTo/Pages/?u=http%3A%2F%2Fwww.starticket.ch%2F0ShowInfo.asp%3FShowID%3D29649%26ShowDetails%3D1
		 * 			&t=Alex+Gopher+%28FR%29+%2B+Punks+Jump+Up+%28UK%29+%2B+Dan+%28Digitales+Natives%29+Rocking+Chair+%2Astarticket
		 * 			&c=%3Cimg+src%3D%22http%3A%2F%2Fwww%2Estarticket%2Ech%2Fpictures%2Frkc%5Falexgopher%2Ejpg%22+width%3D%22180%22+height%3D%22135%22+border%3D%220%22%3E%3Cbr%3E%3Cbr%3E%3Cb+class%3D%22gray%22%3ET%FCr%F6ffnung%3A%3C%2Fb%3E+22%2E00+Uhr%3Cbr%3E%3Cb+class%3D%22gray%22%3EBeginn%3A%3C%2Fb%3E+22%2E00+Uhr%3Cbr%3E%3Cb+class%3D%22gray%22%3EEnde%3A%3C%2Fb%3E+05%2E00+Uhr%3Cbr%3E%3Cbr%3E%3Cb+class%3D%22gray%22%3ERollstuhlpl%E4tze%3A%3C%2Fb%3E+Ben%F6tigen+kein+Ticket+%28freier+Eintritt%29%3Cbr%3E%3Cbr%3E%3Cb+class%3D%22gray%22%3EAltersbegrenzung%3A+%3C%2Fb%3Eab+16+Jahren%3Cbr%3E%3Cbr%3E%3Cb+class%3D%22gray%22%3EWeitere+Infos%3A%3C%2Fb%3E%3Cbr%3E%3Ca+target%3D%22blank%22+href%3D%22http%3A%2F%2Fwww%2Erocking%2Dchair%2Ech%22%3Ewww%2Erocking%2Dchair%2Ech%3C%2Fa%3E%3Cbr%3E%3Ca+target%3D%22blank%22+href%3D%22http%3A%2F%2Fwww%2Emyspace%2Ecom%2Falexgopher%22%3Ewww%2Emyspace%2Ecom%2Falexgopher%3C%2Fa%3E%3Cbr%3E%3Ca+target%3D%22blank%22+href%3D%22http%3A%2F%2Fwww%2Emyspace%2Ecom%2Fpunksjumpup%22%3Ewww%2Emyspace%2Ecom%2Fpunksjumpup%3C%2Fa%3E%3Cbr%3E%3Ca+target%3D%22blank%22+href%3D%22http%3A%2F%2Fwww%2Emyspace%2Ecom%2Fthedigitalnatives%22%3Ewww%2Emyspace%2Ecom%2Fthedigitalnatives%3C%2Fa%3E%3Cbr%3E%3C%21%2D%2D+%2D%2D%2DK%2DO%2D%2D%2DC%2DP%2D%2D%2D+%2D%2D%3E
		 */
		com.google.gwt.user.client.ui.Image myspace = UIFactory.createImageButton(Images.images.myspace().createImage());
		myspace.setTitle("Share on Myspace");
		myspace.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				//TODO 000 test this
				String url = "http://www.myspace.com/Modules/PostTo/Pages/?u=" + linkWithID +
				"&t=" + title +
				"&c=TODOnotSureWhatToPutHere"; //TODO c?
				String features = "menubar=no, status=no, titlebar=no, toolbar=no";
				Window.open(url, "_blank", features);
			}
		});
		hp.add(myspace);
		
		/****************************
		 * del.icio.us
		 *
		 * http://del.icio.us/post?url=http%3A%2F%2Fwww.starticket.ch%2F0ShowInfo.asp%3FShowID%3D29649%26ShowDetails%3D1
		 * 		&title=Alex+Gopher+%28FR%29+%2B+Punks+Jump+Up+%28UK%29+%2B+Dan+%28Digitales+Natives%29+Rocking+Chair+%2Astarticket

		 */
		com.google.gwt.user.client.ui.Image del = UIFactory.createImageButton(Images.images.delicious().createImage());
		del.setTitle("Share on del.icio.us");
		del.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				//TODO 000 test this
				String url = "http://del.icio.us/post?url=" + linkWithID +
				"&title=" + title;
				String features = "menubar=no, status=no, titlebar=no, toolbar=no";
				Window.open(url, "_blank", features);
			}
		});

		hp.add(del);
	}

}
