/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.to;

import java.util.List;

import uk.co.maxant.gwtdemo.client.to.Design;

/**
 * an artist
 */
public class Artist extends User implements java.io.Serializable, Displayable {

	private static final long serialVersionUID = 1L;

	private String description;
	private List<Design> designs;
	private boolean imageExists;

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public List<Design> getDesigns() {
		return designs;
	}

	public void setDesigns(List<Design> designs) {
		this.designs = designs;
	}

	public String getLongToolTip() {
		return null;
	}
	
	public String getToolTip() {
		return null;
	}

	/**
	 * @return the url to the image, or that of the "unknown" image, if none exists.
	 */
	public String getUrl() {
		if(isImageExists()){
			return "/images/artists/artist_" + getUid() + ".jpg";
		}else{
			return "/images/artists/artist_unknown.jpg";
		}
	}
	
	public String getName() {
		return getScreenname();
	}
	
	public String getType() {
		return ARTIST;
	}

	@Override
	public String toString() {
		return "Artist " + uid;
	}

	public boolean isImageExists() {
		return imageExists;
	}

	public void setImageExists(boolean imageExists) {
		this.imageExists = imageExists;
	}
}
