/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.to;

import java.io.Serializable;

/**
 * transfer object for paypal config out of the server.
 * 
 * see Table A.2 in PP_WebsitePaymentsStandard_IntegrationGuide.pdf
 */
public class PaypalConfig implements Serializable {

	private static final long serialVersionUID = 1L;

	protected String paypalMerchantEmail;
	protected String paypalURL;
	protected String total;
	protected String itemName;
	protected String orderUid;
	protected String cancelReturnURL;
	protected String email;
	protected String continueButtonText;
	protected String logo;
	protected String allowShippingAddress;
	protected String returnURL;
	protected String ipnURL;
	protected String paypalCurrency;
	protected String language;
	protected String shipping;
	protected String tax;

	public String getPaypalMerchantEmail() {
		return paypalMerchantEmail;
	}
	public void setPaypalMerchantEmail(String paypalMerchantEmail) {
		this.paypalMerchantEmail = paypalMerchantEmail;
	}
	public String getPaypalURL() {
		return paypalURL;
	}
	public void setPaypalURL(String paypalURL) {
		this.paypalURL = paypalURL;
	}
	public String getTotal() {
		return total;
	}
	public void setTotal(String total) {
		this.total = total;
	}
	public String getItemName() {
		return itemName;
	}
	public void setItemName(String itemName) {
		this.itemName = itemName;
	}
	public String getOrderUid() {
		return orderUid;
	}
	public void setOrderUid(String orderUid) {
		this.orderUid = orderUid;
	}
	public String getCancelReturnURL() {
		return cancelReturnURL;
	}
	public void setCancelReturnURL(String cancelReturnURL) {
		this.cancelReturnURL = cancelReturnURL;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getContinueButtonText() {
		return continueButtonText;
	}
	public void setContinueButtonText(String continueButtonText) {
		this.continueButtonText = continueButtonText;
	}
	public String getLogo() {
		return logo;
	}
	public void setLogo(String logo) {
		this.logo = logo;
	}
	public String getAllowShippingAddress() {
		return allowShippingAddress;
	}
	public void setAllowShippingAddress(String allowShippingAddress) {
		this.allowShippingAddress = allowShippingAddress;
	}
	public String getReturnURL() {
		return returnURL;
	}
	public void setReturnURL(String returnURL) {
		this.returnURL = returnURL;
	}
	public String getIpnURL() {
		return ipnURL;
	}
	public void setIpnURL(String ipnURL) {
		this.ipnURL = ipnURL;
	}
	public String getPaypalCurrency() {
		return paypalCurrency;
	}
	public void setPaypalCurrency(String paypalCurrency) {
		this.paypalCurrency = paypalCurrency;
	}
	public String getLanguage() {
		return language;
	}
	public void setLanguage(String language) {
		this.language = language;
	}
	public String getShipping() {
		return shipping;
	}
	public void setShipping(String shipping) {
		this.shipping = shipping;
	}
	public String getTax() {
		return tax;
	}
	public void setTax(String tax) {
		this.tax = tax;
	}
}
