/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.to;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import uk.co.maxant.gwtdemo.client.util.ClientFormats;

/**
 */
public class SalesOrder  implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

     private Integer uid;
     private User customer;
     private String email;
     private String paymentType;
     private double deliveryTotal;
     private String deliveryDescription;
     private String paymentDetails;
     private Date statusOrderCreated;
     private Date statusOrderPlaced;
     private Date statusPaymentSuccessful;
     private Date statusPaymentFailed;
     private Date statusAwaitingPicking;
     private Date statusStartedPicking;
     private Date statusFinishedPicking;
     private Date statusReadyForDispatch;
     private Date statusDispatched;
     private Date statusDelivered;
     private Date statusDiscarded;
     private Date statusCancelled;
     private boolean needsAttention;
     private String txnId;
     private String ppMcCurrency;
     private double taxCost;
     private String customerNotes;
     private String shopNotes;
     private boolean isGift;
     private Staff pickedBy;
     private List<SalesOrderItem> salesOrderItems = new ArrayList<SalesOrderItem>(0);

    public SalesOrder() {
    }

    public Integer getUid() {
        return this.uid;
    }
    
    public void setUid(Integer uid) {
        this.uid = uid;
    }
    public User getCustomer() {
        return this.customer;
    }
    
    public void setCustomer(User customer) {
        this.customer = customer;
    }
    public String getEmail() {
        return this.email;
    }
    
    public void setEmail(String email) {
        this.email = email;
    }
    public String getPaymentType() {
        return this.paymentType;
    }
    
    public void setPaymentType(String paymentType) {
        this.paymentType = paymentType;
    }
    public double getDeliveryTotal() {
        return this.deliveryTotal;
    }
    
    public void setDeliveryTotal(double deliveryTotal) {
        this.deliveryTotal = deliveryTotal;
    }
    public String getDeliveryDescription() {
        return this.deliveryDescription;
    }
    
    public void setDeliveryDescription(String deliveryDescription) {
        this.deliveryDescription = deliveryDescription;
    }
    public String getPaymentDetails() {
        return this.paymentDetails;
    }
    
    public void setPaymentDetails(String paymentDetails) {
        this.paymentDetails = paymentDetails;
    }
    public Date getStatusOrderCreated() {
        return this.statusOrderCreated;
    }
    
    public void setStatusOrderCreated(Date statusOrderCreated) {
        this.statusOrderCreated = statusOrderCreated;
    }
    public Date getStatusOrderPlaced() {
        return this.statusOrderPlaced;
    }
    
    public void setStatusOrderPlaced(Date statusOrderPlaced) {
        this.statusOrderPlaced = statusOrderPlaced;
    }
    public Date getStatusPaymentSuccessful() {
        return this.statusPaymentSuccessful;
    }
    
    public void setStatusPaymentSuccessful(Date statusPaymentSuccessful) {
        this.statusPaymentSuccessful = statusPaymentSuccessful;
    }
    public Date getStatusPaymentFailed() {
        return this.statusPaymentFailed;
    }
    
    public void setStatusPaymentFailed(Date statusPaymentFailed) {
        this.statusPaymentFailed = statusPaymentFailed;
    }
    public Date getStatusAwaitingPicking() {
        return this.statusAwaitingPicking;
    }
    
    public void setStatusAwaitingPicking(Date statusAwaitingPicking) {
        this.statusAwaitingPicking = statusAwaitingPicking;
    }
    public Date getStatusStartedPicking() {
        return this.statusStartedPicking;
    }
    
    public void setStatusStartedPicking(Date statusStartedPicking) {
        this.statusStartedPicking = statusStartedPicking;
    }
    public Date getStatusFinishedPicking() {
        return this.statusFinishedPicking;
    }
    
    public void setStatusFinishedPicking(Date statusFinishedPicking) {
        this.statusFinishedPicking = statusFinishedPicking;
    }
    public Date getStatusReadyForDispatch() {
        return this.statusReadyForDispatch;
    }
    
    public void setStatusReadyForDispatch(Date statusReadyForDispatch) {
        this.statusReadyForDispatch = statusReadyForDispatch;
    }
    public Date getStatusDispatched() {
        return this.statusDispatched;
    }
    
    public void setStatusDispatched(Date statusDispatched) {
        this.statusDispatched = statusDispatched;
    }
    public Date getStatusDelivered() {
        return this.statusDelivered;
    }
    
    public void setStatusDelivered(Date statusDelivered) {
        this.statusDelivered = statusDelivered;
    }
    public Date getStatusDiscarded() {
		return statusDiscarded;
	}

	public void setStatusDiscarded(Date statusDiscarded) {
		this.statusDiscarded = statusDiscarded;
	}
    public Date getStatusCancelled() {
        return this.statusCancelled;
    }
    
    public void setStatusCancelled(Date statusCancelled) {
        this.statusCancelled = statusCancelled;
    }
    public boolean isNeedsAttention() {
        return this.needsAttention;
    }
    
    public void setNeedsAttention(boolean needsAttention) {
        this.needsAttention = needsAttention;
    }
    public String getTxnId() {
        return this.txnId;
    }
    
    public void setTxnId(String txnId) {
        this.txnId = txnId;
    }
    public String getPpMcCurrency() {
        return this.ppMcCurrency;
    }
    
    public void setPpMcCurrency(String ppMcCurrency) {
        this.ppMcCurrency = ppMcCurrency;
    }
    public double getTaxCost() {
        return this.taxCost;
    }
    
    public void setTaxCost(double taxCost) {
        this.taxCost = taxCost;
    }
    public String getCustomerNotes() {
        return this.customerNotes;
    }
    
    public void setCustomerNotes(String customerNotes) {
        this.customerNotes = customerNotes;
    }
    public String getShopNotes() {
        return this.shopNotes;
    }
    
    public void setShopNotes(String shopNotes) {
        this.shopNotes = shopNotes;
    }
    public boolean isIsGift() {
        return this.isGift;
    }
    
    public void setIsGift(boolean isGift) {
        this.isGift = isGift;
    }
    public Staff getPickedBy() {
        return this.pickedBy;
    }
    
    public void setPickedBy(Staff pickedBy) {
        this.pickedBy = pickedBy;
    }
    public List<SalesOrderItem> getSalesOrderItems() {
        return this.salesOrderItems;
    }
    
    public void setSalesOrderItems(List<SalesOrderItem> salesOrderItems) {
        this.salesOrderItems = salesOrderItems;
    }

	public double getTotal() {
		double t = 0.0;
		for(SalesOrderItem soi : getSalesOrderItems()){
			double discountFactor = 100 - soi.getSpecialOfferDiscount();
			discountFactor /= 100.0;
			double t2 = (discountFactor * soi.getBasePrice()) + soi.getAdditionalDeliveryCharge();
			t += (soi.getQuantity() * t2);
		}

		t += this.getDeliveryTotal();
		
		return t;
	}

	public String getPaymentStatusHTML() {
		String s = "";
		if(getStatusPaymentSuccessful() != null){
			if(getStatusPaymentFailed() != null){
				//depends which is newer
				if(getStatusPaymentFailed().before(getStatusPaymentSuccessful())){
					s = "<img src='/images/ui/payment_ok.png' />&nbsp;Succeeded: " + ClientFormats.DTF_ddMMMyyyyHHmm.format(getStatusPaymentSuccessful()) + "<br>";
				}else{
					s = "<img src='/images/ui/payment_nok.png' />&nbsp;Failed: " + ClientFormats.DTF_ddMMMyyyyHHmm.format(getStatusPaymentFailed()) + "<br>";
				}
			}else{
				s = "<img src='/images/ui/payment_ok.png' />&nbsp;Succeeded: " + ClientFormats.DTF_ddMMMyyyyHHmm.format(getStatusPaymentSuccessful()) + "<br>";
			}
		}else if(getStatusPaymentFailed() != null){
			s = "<img src='/images/ui/payment_nok.png' />&nbsp;Failed: " + ClientFormats.DTF_ddMMMyyyyHHmm.format(getStatusPaymentFailed()) + "<br>";
		}else {
			s = "<img src='/images/ui/warning.png' />&nbsp;Unknown";
		}
		return s;
	}

}


