/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.to;

import java.io.Serializable;
import java.util.List;

/**
 * when searching, this object is returned to differentiate matching designs
 * and matching artists.
 */
public class SearchResults implements Serializable {

	private static final long serialVersionUID = 1L;

	protected List<Design> designs;

	protected List<Artist> artists;

	public SearchResults(){
		//this constructor is here for GWT serialisation
	}

	public SearchResults(List<Design> designs, List<Artist> artists) {
		this.designs = designs;
		this.artists = artists;
	}

	public List<Design> getDesigns() {
		return designs;
	}

	public List<Artist> getArtists() {
		return artists;
	}

	public void setArtists(List<Artist> artists) {
		this.artists = artists;
	}

	public void setDesigns(List<Design> designs) {
		this.designs = designs;
	}
	
	
}
