/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.to;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.List;


/**
 */
public class SessionInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    private Integer userUid;

    private String login;

    private String firstname;

    private String lastname;

    private String sessionId;
    
	private List<String> roles = new ArrayList<String>();

    private List<Artist> allArtists = new ArrayList<Artist>();

    private String[] spotlights;
    
    private boolean designCommentModerationActive = false;
    
    /**
     * default constructor.
     */
    public SessionInfo() {
    }

    /**
     * @return  empty, unless user is admin
     */
    public List<Artist> getAllArtists() {
        return allArtists;
    }

    /**
     * DOCUMENT ME!
     *
     * @return  DOCUMENT ME!
     */
    public List<String> getRoles() {
        return roles;
    }

    /**
     * DOCUMENT ME!
     *
     * @return  DOCUMENT ME!
     */
    public String getFirstname() {
        return firstname;
    }

    public String getLastname() {
		return lastname;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	/**
     * @param  firstname
     */
    public void setFirstname(String firstname) {
        this.firstname = firstname;
    }

    /**
     * DOCUMENT ME!
     *
     * @return  DOCUMENT ME!
     */
    public String getSessionId() {
        return sessionId;
    }

    /**
     * @param  sessionId
     */
    public void setSessionId(String sessionId) {
        this.sessionId = sessionId;
    }

    /**
     * DOCUMENT ME!
     *
     * @return  DOCUMENT ME!
     */
    public Integer getUserUid() {
        return this.userUid;
    }

    /**
     * @param  userUid
     */
    public void setUserUid(Integer userUid) {
        this.userUid = userUid;
    }

    public String getLogin() {
        return this.login;
    }

    /**
     * @param  login
     */
    public void setLogin(String login) {
        this.login = login;
    }

    public boolean isLoggedIn() {
        return login != null;
    }

	public String[] getSpotlights() {
		return spotlights;
	}

	public void setSpotlights(String[] spotlights) {
		this.spotlights = spotlights;
	}


    /**
     * DOCUMENT ME!
     *
     * @param   role  DOCUMENT ME!
     *
     * @return  DOCUMENT ME!
     */
    public boolean isInRole(String role) {
        return roles.contains(role);
    }

	public String getFullname() {
		String n = "";
		if(getFirstname() != null){
			n = getFirstname();
			if(n.length() > 0) n += " ";
		}
		if(getLastname() != null){
			n += getLastname();
		}
		return n;
	}

	public boolean isDesignCommentModerationActive() {
		return designCommentModerationActive;
	}

	public void setDesignCommentModerationActive(
			boolean designCommentModerationActive) {
		this.designCommentModerationActive = designCommentModerationActive;
	}

}
