/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.to;

import java.util.Date;

/**
 * an artist, staff or customer.
 */
public class User implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

	protected Integer uid;
	protected String email;
	protected String title;
	protected String firstname;
	protected String lastname;
	protected Date registrationDate;
	protected String notes;
	private Date dob;
	private String screenname; /* artist have one, obvious. customers also have one for feedback, as do staff */
	private String preferredLocale;
	private String phone;
	private String mobile;
	private boolean joinedMailingList;
	private boolean joinedMobileList;
	private String whereHeardAbout;
	private boolean isArtist;
	private boolean isStaff;

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public Date getRegistrationDate() {
		return registrationDate;
	}

	public void setRegistrationDate(Date registrationDate) {
		this.registrationDate = registrationDate;
	}

	public String getNotes() {
		return notes;
	}

	public void setNotes(String notes) {
		this.notes = notes;
	}

	public Integer getUid() {
		return uid;
	}

	public void setUid(Integer uid) {
		this.uid = uid;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getFirstname() {
		return firstname;
	}

	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}

	public String getLastname() {
		return lastname;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	public void setDob(Date dob) {
		this.dob = dob;
	}

	public Date getDob() {
		return dob;
	}

	public String getScreenname() {
		return screenname;
	}

	public void setScreenname(String screenname) {
		this.screenname = screenname;
	}

	public String getPreferredLocale() {
		return this.preferredLocale;
	}

	public void setPreferredLocale(String preferredLocale) {
		this.preferredLocale = preferredLocale;
	}

	public String getPhone() {
		return this.phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public String getMobile() {
		return this.mobile;
	}

	public void setMobile(String mobile) {
		this.mobile = mobile;
	}

	public boolean isJoinedMailingList() {
		return this.joinedMailingList;
	}

	public void setJoinedMailingList(boolean joinedMailingList) {
		this.joinedMailingList = joinedMailingList;
	}

	public boolean isJoinedMobileList() {
		return this.joinedMobileList;
	}

	public void setJoinedMobileList(boolean joinedMobileList) {
		this.joinedMobileList = joinedMobileList;
	}

	public String getWhereHeardAbout() {
		return this.whereHeardAbout;
	}

	public void setWhereHeardAbout(String whereHeardAbout) {
		this.whereHeardAbout = whereHeardAbout;
	}

	/**
	 * @return concatenated and trimmed first + last name.
	 */
	public String getFullName() {
		String s = getFirstname();
		if(s != null && s.trim().length() > 0){
			s = s.trim();
			if(getLastname() != null){
				s += " " + getLastname().trim();
			}
		}else{
			s = getLastname();
			if(s == null){
				s = "";
			}else{
				s = s.trim();
			}
		}
		
		return s;
	}

	public boolean isArtist() {
		return isArtist;
	}

	public boolean isStaff() {
		return isStaff;
	}

	public void setArtist(boolean isArtist) {
		this.isArtist = isArtist;
	}

	public void setStaff(boolean isStaff) {
		this.isStaff = isStaff;
	}

}
