/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.util;

public class StringUtil {

	private StringUtil(){}
	
	/**
	 * @return what it says on the tin. otherwise, the original string is returned.
	 */
	public static String getHTMLSpaceIfNullOrEmpty(String s){
		if(s == null){
			return "&nbsp;";
		}else{
			if(s.trim().length() == 0){
				return "&nbsp;";
			}else{
				return s;
			}
		}
	}

	/**
	 * if the given string has any words more than X chars, then the sentence is trimmed at that 
	 * point, and "..." is appended.
	 */
	public static String trimToLengthIfNoWhitespace(String name, int x) {
		String s = "";
		int lastWhiteSpace = -1;
		for(int i = 0; i < name.length(); i++){
			char c = name.charAt(i);
			if(isWhitespace(c)){
				lastWhiteSpace = i;
			}
			if(i - lastWhiteSpace > x){
				s += "...";
				break;
			}else{
				s += c;
			}
		}
		return s;
	}

	/**
	 * implemented ourselves, as opposed to taken from {@link Character#isWhitespace(char)} since
	 * GWT 1.7 doesnt like that method in character. complains that it cant find it and wont compile...
	 */
	private static boolean isWhitespace(char c){
        if(c == ' '){
        	return true;
        }else if(c == '\r'){
        	return true;
        }else if(c == '\n'){
        	return true;
        }else if(c == '\t'){
        	return true;
        }

        return false;
	}
	
	public static String getEmptyIfNullOrEmpty(String s) {
		if(s == null){
			return "";
		}else{
			if(s.trim().length() == 0){
				return "";
			}else{
				return s;
			}
		}
	}
	
	public static void main(String[] args) {
		//test trimToLengthIfNoWhitespace()
		
		System.out.println(trimToLengthIfNoWhitespace("abcde abcdefghijklmnop", 10));
	}
	
}
