/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.widgets.core;

import uk.co.maxant.gwtdemo.client.to.SessionInfo;
import uk.co.maxant.gwtdemo.client.util.AsyncCallbackImpl;
import uk.co.maxant.gwtdemo.client.widgets.ui.AppWizard;

import com.google.gwt.user.client.rpc.AsyncCallback;

public class WizardController extends WizardServerCaller {

	private AppWizard wizard;

	public WizardController(AppWizard wizard){
		super(wizard);

		this.wizard = wizard;
	}
	
	public void getSessionInfoAndMasterData() {
        AsyncCallback<SessionInfo> callback = new AsyncCallbackImpl<SessionInfo>(this) {

            public void onSuccess_(SessionInfo info) {
                wizard.getModel().setSessionInfo(info);
                wizard.notifyMasterDataIsReady();
            }
        };
		callServer();
		getServiceClient().getSessionInfo(callback);
	}


}
