/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.widgets.ui;

import uk.co.maxant.gwtdemo.client.generic.widgets.AbstractInputDialog;
import uk.co.maxant.gwtdemo.client.generic.widgets.UIFactory;

import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;

public class TagInputDialog extends AbstractInputDialog<String> {
	
	private TextBox input;
	
	public TagInputDialog(String title, String message, String validationMessage, final Callback<String> callback) {
		super(title, message, validationMessage, callback);
	}
	
	@Override
	protected Widget createContents() {
		input = UIFactory.createTextBox();
		return input;
	}

	protected boolean validate(){
		if(input.getText().trim().length() > 0){
			data = input.getText().trim();
			return true;
		}
		return false;
	}

	@Override
	protected void doInvalid() {
		input.selectAll();
	}
	
	@Override
	public void setFocus(boolean focused) {
		input.setFocus(focused);
	}

}
