/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.client.widgets.ui;

import java.util.List;

import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;

import uk.co.maxant.gwtdemo.client.generic.widgets.Image;
import uk.co.maxant.gwtdemo.client.generic.widgets.UIFactory;
import uk.co.maxant.gwtdemo.client.to.BasketItem;
import uk.co.maxant.gwtdemo.client.widgets.core.ModelListener;
import uk.co.maxant.gwtdemo.client.widgets.core.Waitable;

/**
 * specific impl for this app
 */
public abstract class WizardPage extends uk.co.maxant.gwtdemo.client.generic.widgets.WizardPage implements ModelListener, Waitable {

	private HTML waitLabel;
	
	private Image waitImage;

	public WizardPage(AppWizard wizard) {
		super(wizard);
	}
	
	@Override
	public AppWizard getWizard(){
		return (AppWizard)super.getWizard();
	}
	
	/**
	 * empty impl. subclasses may override this if they want to react to changes in the basket.
	 * @see ModelListener#updateBasket(List)
	 */
	public void updateBasket(List<BasketItem> basketItems) {
	}
	
	/**
	 * @see Waitable#setWait(boolean)
	 */
	public void setWait(boolean waitingForServerResponse) {
		if(waitLabel != null){
			if(waitingForServerResponse){
				waitLabel.setHTML("&nbsp;making server request...");
			}else{
				waitLabel.setHTML("&nbsp;");
			}
		}
		if(waitImage != null){
			if(waitingForServerResponse){
				waitImage.setVisible(true);
			}else{
				waitImage.setVisible(false);
			}
		}
	}

	/**
	 * @return an hp containing the wait widgets.
	 */
	public HorizontalPanel createWait(){
		HorizontalPanel hp = UIFactory.createHorizontalPanel();
		hp.setHeight("24px");
		hp.setVerticalAlignment(HasVerticalAlignment.ALIGN_BOTTOM);
		waitImage = new Image("/images/wait.gif");
		waitImage.setVisible(false);
		hp.add(waitImage);
		waitLabel = new HTML();
		waitLabel.setStyleName("smallText");
		hp.add(waitLabel);
		return hp;
	}

}
