/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.server.util;

import java.text.SimpleDateFormat;
import java.util.Date;

public class Environment {

	private Environment(){
	}
	
	private static SimpleDateFormat yyyy(){
		return new SimpleDateFormat("yyyy");
	}
	private static String thisYear;
	private static Date lastUpdateThisYear = new Date();

	/**
	 * Gets this year as a string, using a cached object which is refreshed daily.
	 * @return
	 */
	private static String getThisYear(){
		if(thisYear == null || lastUpdateThisYear.before(new Date(System.currentTimeMillis()-24*3600000L))){
			//its more than a day old, or hasnt been set
			lastUpdateThisYear = new Date();
			thisYear = yyyy().format(lastUpdateThisYear);
		}
		return thisYear;
	}
	
	public static String getCopyrightNotice(String startYear){
		String ret = "Copyright &copy; " + startYear;
		if(!getThisYear().equals(startYear)) ret += "-" + getThisYear();
		return ret;
	}
}
