/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.server.util;

import org.apache.log4j.Logger;

/**
 * Helps with the creation of loggers as follows:
 *
 * import org.apache.log4j.Logger;
 * <br>
 * public class ...<br>
 * <br>
 * &nbsp;&nbsp;&nbsp;&nbsp;private static final Logger log = LogHelper.getLog();
 */
public class LogHelper {

	/** Class cant be instantiated */
	LogHelper(){}

//	private static boolean inited = false;

	private static void init(){
//		if(!inited){
////			System.out.println(new File(".").getAbsolutePath());
//			DOMConfigurator.configure("log4j.xml");
//			inited = true;
//		}
	}

	public static Logger getLog(){
		return getLog(getClassName());
	}

	public static Logger getLog(String name){
		init();
		return Logger.getLogger(name);
	}

	/**
	 * @return the name of the class calling this method.
	 */
	private static String getClassName(){
		Throwable t = new Throwable();
	    StackTraceElement directCaller = t.getStackTrace()[2];
	    return directCaller.getClassName();
	}

	public static void main(String[] args){
		Logger log = getLog();
		log.info("hello world");
	}

}
