/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.server.util;

import java.util.Random;

public class PasswordGenerator {

	private static Random random = new Random();
	
	private static final char[] chars = {'B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'X', 'Y', 'Z', '2', '3', '4', '5', '6', '7', '8', '9' };
	
	private PasswordGenerator(){}

	/**
	 * @return a password generated between 6 and 10 chars long, mixed case.
	 */
	public static String generatePassword() {
		return generatePassword(6, 10);
	}

	public static String generatePassword(int minLength, int maxLength) {
		
		int length = random.nextInt(maxLength-minLength) + minLength;
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i <= length; i++){
			char c = chars[random.nextInt(chars.length)];
			String s = new String(new char[]{c});
			if(random.nextBoolean()){
				s = s.toLowerCase();
			}
			sb.append(s);
		}
		return sb.toString();
	}
	
	public static void main(String[] args) {
		for(int i = 0; i < 20; i++){
			System.out.println(generatePassword());
		}
	}
	
	
}
