/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.server.util;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;

public class ServerFormats {

	public static final SimpleDateFormat yyyyMMddHHmmssSSS(){
		return new SimpleDateFormat("yyyyMMddHHmmssSSS");
	}

	public static final SimpleDateFormat EEE_dd_MMM_yyyy_HH_mm_ss_sss(){
		return new SimpleDateFormat("EEE, dd MMM, yyyy HH:mm:ss.SSS");
	}

	public static final long SECOND = 1000L;
	
	public static final long MINUTE = 60 * SECOND;
	
	public static final long HOUR = 60 * MINUTE;

	public static final long DAY = 24 * HOUR;

	public static final long _28_DAYS = 28 * DAY;

	public static final NumberFormat NF_0_00(){
		return new DecimalFormat("#,##0.00");
	}

	protected ServerFormats(){}
}
