/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.server.util;

import java.util.Locale;

import org.springframework.context.MessageSource;

import uk.co.maxant.gwtdemo.util.ResourceHelper;

public class SpringResourceHelper implements ResourceHelper {

	protected MessageSource messageSource;
	
	protected Locale locale = Locale.ENGLISH;

	public SpringResourceHelper(MessageSource messageSource){
		this.messageSource = messageSource;
	}
	
	public String getMessage(String key, Object... args){
		return messageSource.getMessage(key, args, locale);
	}

	public String getMessage(String key){
		return getMessage(key, (Object[])null);
	}
	
	public void setLocale(Locale locale) {
		this.locale = locale;
	}

}
