/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.util;

public class StringUtils {

	public static String replaceAll(String original, String delimiter, String newDelimiter){
		StringBuilder sb = new StringBuilder(original);
		int index = 0;
		while((index = sb.indexOf(delimiter, index)) != -1){
			sb.replace(index, index+delimiter.length(), newDelimiter);
			index += newDelimiter.length();
		}
		return sb.toString();
	}

	public static void main(String[] args) throws Exception {
		
		if(!replaceAll("\r\n\r\nas\r\ndf\r\n", "\r\n", "<br>").equals("<br><br>as<br>df<br>")) throw new Exception("Failed 1");
		if(!replaceAll("\r\nas\r\n\r\ndf\r\n\r\n", "\r\n", "<br>").equals("<br>as<br><br>df<br><br>")) throw new Exception("Failed 2");
		System.out.println("done!");
	}
	
	/**
	 * @return the same string, but with &lt; and &gt; replaced by &amp;lt; and &amp;gt;
	 */
	public static String stripHTML(String comment) {
		String s = comment.replaceAll("<", "&lt;");
		s = s.replaceAll(">", "&gt;");
		return s;
	}

}

