/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package uk.co.maxant.gwtdemo.server;

import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;

import uk.co.maxant.gwtdemo.client.ApplicationException;
import uk.co.maxant.gwtdemo.server.PartyService.ArtistViewStat;
import uk.co.maxant.gwtdemo.server.util.DependencyResolver;
import uk.co.maxant.gwtdemo.server.util.LogHelper;

import junit.framework.TestCase;

public class DesignServiceTest extends TestCase {

	private static Logger log = LogHelper.getLog();
	
	@Autowired
	private PartyService partyService;
	
	@Override
	protected void setUp() throws Exception {
		System.setProperty("java.naming.factory.initial", "uk.co.maxant.gwtdemo.tooling.InitialContextFactory");
		DependencyResolver.resolve(this);
	}
	
	public void testStats(){
		try {
			List<ArtistViewStat> stats = partyService.getArtistViewStats();
			
			//build a string containing the names build like this: 9 7 5 3 1 2 4 6 8
			//that way, when its wrapped it will look cool and the most importnat ones will
			//be in the middle
			boolean addAtFront = true;
			String s = "";
			for(ArtistViewStat avs : stats){
				String t = " \"" + avs.artist.getScreenname() + "\" ";
				if(addAtFront){
					s = t + s;
				}else{
					s += t;
				}
				addAtFront = !addAtFront;
			}
			
			System.out.println(s);
		} catch (ApplicationException e) {
			log.error(e);
			fail("Failed to get stats: " + e.getMessage());
		}
	}
}
