package uk.co.maxant.spring.security;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

/**
 * simple filter which sets the request into the security helper for each server request,
 * hence making it available for use further along the callstack.
 */
public class SecurityFilter implements Filter {

	public void destroy() {
	}

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {

		try{
			//set the request in the security thread local
			SecurityHelper.set((HttpServletRequest)request);
			
			chain.doFilter(request, response);
		}finally{
			//all done, so remove references to unwanted objects
			SecurityHelper.finished();
		}
	}

	public void init(FilterConfig filterConfig) throws ServletException {
	}

}
