<%
/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

%>
<%@page import="uk.co.maxant.gwtdemo.server.util.LogHelper"%>
<%@page import="org.apache.log4j.Logger"%>
<%@page import="uk.co.maxant.gwtdemo.client.ApplicationException"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.ServiceLocator"%>
<%@page import="org.apache.tools.ant.util.FileUtils"%>
<%@page import="java.io.File"%>
<%@page import="uk.co.maxant.gwtdemo.client.Roles"%>
<%@page import="org.apache.commons.fileupload.FileItem"%>
<%@page import="org.apache.commons.fileupload.servlet.ServletFileUpload"%>
<%@page import="org.apache.commons.fileupload.disk.DiskFileItemFactory"%>
<%@page import="org.apache.commons.fileupload.FileItemFactory"%>
<%@page import="java.util.List"%>
<%@page import="org.apache.commons.fileupload.FileUploadBase.SizeLimitExceededException"%>
<%@page import="uk.co.maxant.gwtdemo.server.MailService"%>
<%@page import="uk.co.maxant.gwtdemo.server.ConfigService"%>
<%
Logger log = LogHelper.getLog();
boolean ok = false;

//only callable by artists
if(request.getUserPrincipal() == null){
	%>MUST be logged in to upload new designs. NDUP001<%
}else{
	final int MAX_SIZE_BYTES = 4*1024*1024; //4 meg

	String uid = null;
	File temp = null;
	String filename = null;
	String contentType = null;
	try{
		temp = File.createTempFile("newDesignUpload", ".tmp", new File("../temp"));
		FileItemFactory factory = new DiskFileItemFactory(0, new File("../temp"));
		ServletFileUpload upload = new ServletFileUpload(factory);
		upload.setSizeMax(MAX_SIZE_BYTES);
		for(FileItem item : (List<FileItem>)upload.parseRequest(request)){
			if (item.isFormField()) {
				String name = item.getFieldName();
			    String value = item.getString();
			    if(name.equals("uid")){
			    	uid = value;
			    }
			} else {
				String fieldName = item.getFieldName();
				if(fieldName.equals("data")){
					item.write(temp);
					filename = item.getName();
					contentType = item.getContentType();
				}
				
//				d.setData(data);
//				d.setFilename(item.getName());
//			    String fileName = item.getName();
//			    String contentType = item.getContentType();
//			    boolean isInMemory = item.isInMemory();
//			    long sizeInBytes = item.getSize();
//			    byte[] data = item.get();

			}
		}
		
		//ok, lets write email the file now:
		MailService ms = ServiceLocator.getInstance().getMailService();
		ConfigService cs = ServiceLocator.getInstance().getConfigService();
		String url = cs.value(ConfigService.httpsUrl);
		String siteName = cs.value(ConfigService.siteName);
		String msg = 
				"Hi,<br><br>" +
				"A new design (ID " + uid + ") has been uploaded. " +
				"The raw data file is attached (" + filename + " - " + contentType +").<br><br>" +
				"Please process this design and log into <a href='" + url + "/secure/'>" + siteName + "</a> " +
				"and update the designs images before approving it. Once approved, the design will be live for " +
				"customers to purchase.";
		ms.sendMail(cs.value(ConfigService.emailOps),
				"[New Design Upload] Design ID " + uid,
				msg,
				true /*send bcc*/,
				temp,
				filename);
		
		ok = true;
			
	}catch(SizeLimitExceededException e){
		%>File too large. Maximum file size is <%=MAX_SIZE_BYTES%> bytes.<br><br>NDUP002<br><br><%=e.getMessage()%><%
	}catch(ApplicationException e){
		%><%=e.getMessage() + "<br>" + e.getCode()%><%
	}catch(Exception e){
		%>An error occurred.<br><br><%=e.getMessage()%><br><br>NDUP003<%
	}finally{
		if(temp != null){
			try{
				temp.delete();
			}catch(Exception e){
				String appName = session.getServletContext().getServletContextName();
				String description = "Failed to delete temporary file after a failed new design upload. this file should be deleted manually. The file was: " + temp.getAbsolutePath();
				ServiceLocator.getInstance().getErrorService().reportError(appName, description, e);
			}
		}
	}
}
if(ok){
	%>OK<%
}
%>