<%
/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

%>
<%@page import="java.net.*"%>
<%@page import="java.util.*"%>
<%@page import="org.apache.log4j.Logger"%>
<%@page import="org.apache.commons.httpclient.methods.PostMethod"%>
<%@page import="org.apache.commons.httpclient.HttpClient"%>
<%@page import="org.apache.commons.httpclient.NameValuePair"%>
<%@page import="uk.co.maxant.gwtdemo.server.SalesOrderService"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.ServiceLocator"%>
<%@page import="uk.co.maxant.gwtdemo.server.ConfigService"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.PaymentDetails"%>
<%@page import="uk.co.maxant.gwtdemo.server.OrchestrationService"%>
<jsp:include page="/header.jsp" />
<%
	SalesOrderService salesOrderService = ServiceLocator.getInstance()
			.getSalesOrderService();
	ConfigService configService = ServiceLocator.getInstance()
			.getConfigService();
	Logger log = Logger.getLogger(this.getClass());

	Integer orderNum = null;
	String in = request.getParameter("item_number");
	if (in != null) {
		try {
			orderNum = new Integer(in);
		} catch (NumberFormatException e) {
			//ok, so we really dont know what it is, let it fail lower down.
		}
	}

	log.info("order " + orderNum + " was placed in session "
			+ session.getId());

	String res = null;
	boolean successfulPDTCall = false;
	try {
		String tx = request.getParameter("tx");
		PaymentDetails details = new PaymentDetails(request
				.getParameterMap(), orderNum);
		details.setSource("PayPal Return URL");
		details.setPaymentType("paypal");
		if (tx != null) {
			details.setSource("PayPal PDT");
			//do PDT to get details

			HttpClient client = new HttpClient();
			PostMethod method = new PostMethod(configService.value(
					ConfigService.paypal_payment_url));
			try {
				NameValuePair[] pairs = new NameValuePair[3];
				int i = 0;
				pairs[i++] = new NameValuePair("cmd", "_notify-synch");
				pairs[i++] = new NameValuePair("invoice", String.valueOf(orderNum));
				pairs[i++] = new NameValuePair("tx", tx);
				method.setQueryString(pairs);
				byte[] responseBody = null;
				int statusCode = -1;
				// execute the method.
				statusCode = client.executeMethod(method);
				responseBody = method.getResponseBody();
				res = new String(responseBody);
				if (statusCode == 200) {
					successfulPDTCall = true;
				}
			} finally {
				// release the connection.
				method.releaseConnection();
			}

			//	look at the query string to work out whats going on here! i guess its tokenizing it...
			if (!successfulPDTCall)
				throw new Exception(
						"Failed to get verification response for PayPal PDT for order "
								+ orderNum + ". PDT response was "
								+ res);

			res = res.trim(); //special case to remove white space from front while reading paypalStub response. should have no effect on real paypal response.

			if (res.length() > 6
					&& res.substring(0, 7).equalsIgnoreCase("SUCCESS")) {
				try {
					if (res.length() > 7) {
						//there are more details - lets harvest them!
						Map<String, String> values = new HashMap<String, String>();
						StringTokenizer st = new StringTokenizer(res,
								"\r\n");
						while (st.hasMoreTokens()) {
							String s = st.nextToken();
							String[] ss = s.split("=");
							if (ss != null) {
								if (ss.length > 1) {
									s = "";
									for (int i = 1; i < ss.length; i++) {
										s += ss[i] + "=";
									}
									s = s.substring(0, s.length() - 1); //trim trailing =
									values.put(ss[0], URLDecoder
											.decode(s, "UTF-8"));
								}
							}
						}

						details.setBusiness(values.get("business"));
						details.setCustom(values.get("custom"));

						details.setInvoice(values.get("invoice"));
						details.setMcGross(values.get("mc_gross"));

						details.addExtras("address_status", values
								.get("address_status"));
						details.addExtras("protection_eligibility",
								values.get("protection_eligibility"));
						details.addExtras("address_state", values
								.get("address_state"));
						details.addExtras("handling_amount", values
								.get("handling_amount"));
						details.addExtras("transaction_subject", values
								.get("transaction_subject"));
						details.addExtras("shipping", values
								.get("shipping"));
						details.addExtras("payment_type", values
								.get("payment_type"));

						details.setPayerID(values.get("payer_id"));
						details.setTax(values.get("tax"));
						details.setPaymentDate(values
								.get("payment_date"));
						details.setPaymentStatus(values
								.get("payment_status"));
						details.setFirstName(values.get("first_name"));
						details.setLastName(values.get("last_name"));
						details.setMcFee(values.get("mc_fee"));
						details.setPayerStatus(values
								.get("payer_status"));
						details.setQuantity(values.get("quantity"));
						details
								.setPayerEmail(values
										.get("payer_email"));
						details.setTxnId(values.get("txn_id"));
						details.setReceiverEmail(values
								.get("receiver_email"));
						details
								.setPaymentFee(values
										.get("payment_fee"));
						details
								.setReceiverID(values
										.get("receiver_id"));
						details.setPendingReason(values
								.get("pending_reason"));
						details.setTxnType(values.get("txn_type"));
						details.setItemName(values.get("item_name"));
						details
								.setMcCurrency(values
										.get("mc_currency"));
						details
								.setMcShipping(values
										.get("mc_shipping"));
						if (details.getMcShipping() == null) {
							details.setMcShipping(values
									.get("shipping")); //in tests, mc_shipping aint available, altho shipping is
						}
						details
								.setItemNumber(values
										.get("item_number"));
						details.setResidenceCountry(values
								.get("residence_country"));
						details.setPaymentGross(values
								.get("payment_gross"));
					}
				} catch (Exception e) {
					String msg = "Failed to get details from PayPal PDT repsonse. The order (#"
							+ orderNum
							+ ") was updated anyway, and the customer informed that everything was fine. However, the order needs to be investigated. The response from PDT was:\r\n"
							+ res;
					log.warn(msg, e);
					salesOrderService.markOrderAsNeedingAttention(
							orderNum, msg);

					//in order to avoid failing, we need to set some info inside the paymentDetails, otherwise we get exceptions...
					details.setMcGross("0.00");
					details.setPaymentStatus("failed");
				}
			} else {
				//paypal has reported an error
				String msg = "PayPal has reported a FAIL status in the PDT response.The order (#"
						+ orderNum
						+ ") was updated anyway, and the customer informed that everything was fine. However, the order needs to be investigated. The response from PDT was:\r\n"
						+ res;
				log.warn(msg);
				salesOrderService.markOrderAsNeedingAttention(orderNum,
						msg);

				//in order to avoid failing, we need to set some info inside the paymentDetails, otherwise we get exceptions...
				details.setMcGross("0.00");
				details.setPaymentStatus("failed");
			}
		} else {
			//PDT has not been set up! the client MUST set this up in their paypal account so that 
			//the payment mechanism is more secure.

			//tell them to validate that the payment was really made by looking at their paypal account
			//and verifying that they go the payment
			String msg = "PDT has not been set up for PayPal account! It is imperative that it be set up to ensure secure and reliable payments from PayPal. It can be set up by logging in to PayPal, going to your profile and selecting the Website Payment Preferences. On that screen, set Payment Data Transfer on, and inform maxant of the PDT identity token which PayPal gives you. The system will now attempt to manually process order number "
					+ orderNum + ".";
			log.warn(msg);
		}

		salesOrderService.updatePaymentStatus(details);

		//almost done, lets empty the basket, to avoid confusion!
		session.removeAttribute(OrchestrationService.BASKET);

		String title = "Order Complete";
		String text = "Order number "
				+ orderNum
				+ " has been successfully completed. You will receive an email shortly with details.";
		text += "<br><br><a href='/index.jsp'>home</a>";
%>
<table border="0" width="100%">
	<tr>
		<td width="100%"><img src='/images/stage3banner.jpg' /></td>
	</tr>
	<tr>
		<td width="100%">
		<p class="bigBoldText"><%=title%></p>
		<p class="standardText"><%=text%></p>
		</td>
	</tr>
</table>
<%
	} catch (Exception e) {
		//TODO handle with a mail enabled error handler! otherwise no one will ever see this unless they are trawling logs
		String mapDetails = "";
		Enumeration keys = request.getParameterNames();
		while (keys.hasMoreElements()) {
			String key = (String) keys.nextElement();
			mapDetails += key + "\t\t\t\t" + request.getParameter(key)
					+ "\r\n";
		}
		String msg = "Failed to process payment successfully for order (#"
				+ orderNum
				+ "). Investigate whether it has actually been paid for, and manually update the order to set the payment status so that the order can be processed. Parameters sent from PayPal PDT were:\r\n\r\n"
				+ mapDetails + " and PDT response was:\r\n\r\n" + res;
		log.error(msg, e);
		try {
			salesOrderService.markOrderAsNeedingAttention(orderNum, msg);
		} catch (Exception e2) {
			//TODO handle with a mail enabled error handler! otherwise no one will ever see this unless they are trawling logs
			msg = "Failed to mark order "
					+ orderNum
					+ " as needing attention. Please refer to the error above. THIS ORDER STILL REQUIRES INVESTIGATING!";
			log.error(msg, e);
		}

		msg = "Payment details for order number "
				+ orderNum
				+ " are unclear.<br><br>This problem has been reported to technical support.";
		msg += "<br><br><a href='/index.jsp'>home</a>";
%>
<p class='generalError'>Error</p>
<p class='standardText'><%=msg%></p>
<%
	}

	String mapDetails = "";
	Enumeration keys = request.getParameterNames();
	while (keys.hasMoreElements()) {
		String key = (String) keys.nextElement();
		mapDetails += key + "\t\t\t" + request.getParameter(key)
				+ "\r\n";
	}
	log.info("\r\n\r\nReceived PDT from PayPal:\r\n" + mapDetails
			+ "\r\nResponse was:\r\n" + res + "\r\n\r\n");
%>
<jsp:include page="/footer.jsp" />
