<%
/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

%>
<%@page import="uk.co.maxant.gwtdemo.server.PartyService"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.ServiceLocator"%>
<%@page import="uk.co.maxant.gwtdemo.server.po.Party"%>
<%@page import="java.security.Principal"%>
<%@page import="uk.co.maxant.gwtdemo.server.OrchestrationService"%>


<%@page import="java.net.URLEncoder"%><jsp:include page="/header.jsp" />
<p class='bigBoldText'>Confirm Account Registration</p>
<%
	String error = null;
String confirmation = null;
String email = request.getParameter("email");
String regCode = request.getParameter("regCode");
String action = request.getParameter("action");
try{
	OrchestrationService orchestrationService = ServiceLocator.getInstance().getOrchestrationService();
	if(action != null && action.equals("resend")){
		if(email == null){
%><p class='generalError'>Please enter your email address first.</p><%
	}else{
	orchestrationService.sendRegistrationMail(email, request);
%><p class='generalInfo'>The registration code has been resent to your email address. 
			Please check your email (including your spam folder) and when you have received the code try re-registering on this page.</p><%
	}
	}

	if(email == null){
		email = "";
	}else{
		if(regCode != null){
	//check it against the DB
	final String emailf = email;
	PartyService userService = ServiceLocator.getInstance().getPartyService();
	Party user = userService.getLoggedinUser(new Principal(){
		public String getName(){
	return emailf;
		}
	});
	if(user.getRegCode() != null){
		if(regCode.equals(user.getRegCode())){
	orchestrationService.confirmUserRegistration(user, request);
	confirmation = "Congratulations, you are now fully registered. Please click <a href='/index.jsp'>here</a> to continue.";
		}else{
	error = "The registration code you provided is not valid. Please try again.";
		}
	}else{
		confirmation = "You are already registered. Please click <a href='/index.jsp'>here</a> to continue.";
	}
		}
	}
}catch(Exception e){
	e.printStackTrace();
	error = "An error occurred: " + e.getMessage();
}
	
if(regCode == null){
	regCode = "";
}

if(confirmation != null){
%><p class='generalInfo'><%=confirmation %></p><%
}else{
	if(error != null){
		%><p class='generalError'><%=error %></p><%
	}
	%>
	<p class='standardText'>
	Please confirm your account by entering the following details:
	<form action="confirmRegistration.jsp" method="post" class="standardText">
		Email: <input class='standardText' type="text" name="email" value="<%=email %>"><br>
		Registration Code: <input class='standardText' type="text" name="regCode" value="<%=regCode %>">
			<a href='confirmRegistration.jsp?action=resend&email=<%=URLEncoder.encode(email, "UTF-8") %>'>resend</a>
		<br>
		<button class='standardText' onclick="return submit();" >Confirm Registration</button>
	</form>
	</p>
	<%
}
%>
<jsp:include page="/footer.jsp" />
