<%
/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

%>
<%
String errorTitle = "&nbsp;";
String errorText = "Login";
if(request.getAttribute("FROM_LOGON_ERROR") != null){
	errorTitle = "Login Failed";
	errorText = "Email address should be in small letters. Password is CaSe SeNsiTivE. Please try again.";
}
String account = request.getParameter("j_username");
if(account == null){
	Cookie[] cs = request.getCookies();
	if(cs != null){
		for(Cookie c : cs){
			if(c.getName().equals("username")){
				account = c.getValue();
			}
		}
	}
}
String fieldToHighlight = "j_username";
if(account != null && account.trim().length() > 0){
	fieldToHighlight = "j_password";
}

//get any messages
String message = (String)session.getAttribute("LOGON_MESSAGE");
if(message == null){
	message = "";
}else{
	session.removeAttribute("LOGON_MESSAGE");
}
%>

<jsp:include page="/header.jsp" />

<table width="80%" cellspacing="10" align="center" border="0">
	<tr>
		<td width="1%" align="left" valign="middle">
			<img src='/images/logo.jpg' />
		</td>
	</tr>
	<tr>
		<td width="1%" align="left" valign="middle" class="smallText">
		Log into this demo site using any of the following users:
		<table class="smallText" border="1" cellpadding="0" cellspacing="0" bgcolor="#AAAAAA">
		<tr>
			<th>Username</th>
			<th>Password</th>
			<th>Roles</th>
		</tr>
		<tr>
			<td>andy@maxant.co.uk</td>
			<td>asdf</td>
			<td>artist</td>
		</tr>
		<tr>
			<td>jay@maxant.co.uk</td>
			<td>asdf</td>
			<td>artist, back office, picking</td>
		</tr>
		<tr>
			<td>john@maxant.co.uk</td>
			<td>asdf</td>
			<td>picking</td>
		</tr>
		<tr>
			<td>alex@maxant.co.uk</td>
			<td>asdf</td>
			<td>back office, picking, superAdmin, designCommentsModerator</td>
		</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td class="borderedBox">
		
			<form name="login" action="j_security_check" method=post>
			<table width="100%" border="0">
				<tr>
					<td colspan='2' align="center" class="generalError">
						<%=errorTitle %>
					</td>
				</tr>
				<tr>
					<td colspan='2' align="center" class="standardText">
						<%=errorText %>
					</td>
				</tr>
				<tr>
					<td align='right' class="standardText">
						Email address
					</td>
					<td align='left' class="standardText">
						<input type='text' class="standardText" name="j_username" value="<%=(account==null?"":account.trim()) %>" />
					</td>
				</tr>
				<tr>
					<td align='right' class="standardText">
						Password
					</td>
					<td align='left' class="standardText">
						<input type="password" class="standardText" name="j_password" />
					</td>
				</tr>
				<tr>
					<td align='center' colspan="2" class="standardText">
						<button class='standardText' onclick='disableAllForms(); return submit();'>Login</button>
					</td>
				</tr>
				<tr>
					<td align='center' colspan="2" class="standardText">
						No account? Simply <a href='/index.jsp?screen=7'>register</a>.
					</td>
				</tr>
				<tr>
					<td align='center' colspan="2" class="standardText">
						Forgotten password? Click <a onclick="return fp()" href='#'>here</a>.
					</td>
				</tr>
			</table>
			</form>
		</td>
	</tr>
	<tr>
		<td width="100%" align="center" class="smallText">Powered by <a target="_blank" href='http://www.maxant.co.uk'>max<b>ant</b></a></td>
	</tr>
</table>
		
<SCRIPT language=JavaScript type=text/javascript>
	<!--
	var focusControl = document.forms["login"].elements["<%=fieldToHighlight%>"];
	if (focusControl.type != "hidden") {
		focusControl.focus();
	}

	//copy username into forgotten password form.
	function fp() {
		var form = document.forms["fpForm"];
		var form2 = document.forms["login"];

		var elem = form.elements["email"];
		elem.value = form2.elements["j_username"].value;

		form.submit();
		return true;
	}
	
	// -->
</SCRIPT>
<form action="/forgotPassword.jsp" name="fpForm" method="post" style="margin-bottom:0;" >
	<input type="hidden" name="email" />
</form>
<jsp:include page="/footer.jsp" />
