<%
/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

%>
<%@page import="uk.co.maxant.gwtdemo.server.util.SalesOrderHelper"%>
<%@page import="uk.co.maxant.gwtdemo.server.po.SalesOrder"%>
<%@page import="uk.co.maxant.gwtdemo.server.OrchestrationService"%>
<%@page import="uk.co.maxant.gwtdemo.server.SalesOrderService"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.ServiceLocator"%>
<%@page import="java.util.Map"%>
<%
try{
	SalesOrderService sos = ServiceLocator.getInstance().getSalesOrderService();
	
	String returnURL = request.getParameter("return");
	String cancelURL = request.getParameter("cancel_return");
	String ipnURL = request.getParameter("notify_url");
	String cmd = request.getParameter("cmd");

	if(cmd == null){
		throw new RuntimeException("no cmd provided");
	}

	if(cmd.equals("_ext-enter")){
		//initial call to paypal
		
		//show form to return to website or cancel.
		%>
		<jsp:include page="/header.jsp" />
		You have landed on the Paypal Stub page, from maxant!<br>
		<br>
		Paypal would normally take your payment details. This stub will just pretend that you have done all that 
		and it will then return you to the site. Please click one of the links below:<br><br>
		<a href='<%=cancelURL %>'>cancel payment</a>
		<form action="paypalStub2.jsp" method="post">
			<input type="hidden" name="notify_url" value="<%=ipnURL %>" />
			<input type="hidden" name="invoice" value="<%=request.getParameter("invoice")%>" />
			<input type="hidden" name="return" value="<%=returnURL %>" />
			<input type="checkbox" name="failPDTStatus" />Fail Payment at PDT (IPN wont be sent)?<br>
			<input type="checkbox" name="failPDT" />Fail PDT altogether (IPN wont be sent)?<br>
			<input type="checkbox" name="failIPNStatus" />Fail Payment at IPN?<br>
			<input type="checkbox" name="failIPN" />Fail IPN altogether?<br>
			<input type="submit" value="finish payment" />
		</form>
		<jsp:include page="/footer.jsp" />
		<%
		
	}else if(cmd.equals("_notify-synch")){
		//callback from PDT after returning to website with payment success
		
		//get order out of temp storage, since it isnt in the session, because the jsessionId hasnt been sent to paypal for pdt or ipn
		String tx = request.getParameter("tx").trim();
		Map<String, Object> map = (Map<String, Object>)session.getServletContext().getAttribute(tx); //this aint good - memory leak!
		SalesOrder so = sos.getSalesOrder(Integer.parseInt(request.getParameter("invoice")));
		String pdtStatus = (String)map.get("pdt_st");
		String pdtReturn = (String)map.get("pdt_return");
		//at this stage dont bother giving back 
		//loads of other info. this is just a stub after all.
		%><%=pdtReturn %>
mc_gross=<%=SalesOrderHelper.getGrandTotal(so) %>
st=<%=pdtStatus %>
payment_status=<%=pdtStatus %>
tx=<%=tx %>
txn_id=<%=tx %>
mc_shipping=<%=so.getDeliveryTotal().toString() %>
<%
	}else if(cmd.equals("_notify-validate")){
		//callback from ipn url

		//get order out of temp storage, since it isnt in the session, because the jsessionId hasnt been sent to paypal for pdt or ipn
		String tx = request.getParameter("tx").trim();
		Map<String, Object> map = null;
		java.util.Enumeration ns = session.getServletContext().getAttributeNames();
		while(ns.hasMoreElements()){
			String n = (String)ns.nextElement();
			if(n.trim().equalsIgnoreCase(tx.trim())){
				map = (Map<String, Object>)session.getServletContext().getAttribute(n); //this aint good - memory leak!
				break;
			}
		}
		String ipnReturn = (String)map.get("ipn_return");

		//at this stage dont bother giving back 
		//loads of other info. this is just a stub after all.
		%><%=ipnReturn %>
<%
	}else{
		throw new RuntimeException("unknown cmd: " + cmd);
	}
}catch(Throwable t){
	t.printStackTrace();
	%>
	FAILED: <%=t.getMessage() %>
	<%
}
%>
