<%
/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

%>
<%@page import="uk.co.maxant.gwtdemo.server.SalesOrderService"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.ServiceLocator"%>
<%@page import="uk.co.maxant.gwtdemo.server.OrchestrationService"%>
<%@page import="uk.co.maxant.gwtdemo.server.po.SalesOrder"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.SalesOrderHelper"%>
<%@page import="org.apache.commons.httpclient.HttpClient"%>
<%@page import="org.apache.commons.httpclient.methods.PostMethod"%>
<%@page import="org.apache.commons.httpclient.NameValuePair"%>
<%@page import="java.util.Map"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.UUID"%>
<%
try{
	SalesOrderService sos = ServiceLocator.getInstance().getSalesOrderService();
	String returnURL = request.getParameter("return");
	final String ipnURL = request.getParameter("notify_url");
	final String tx = UUID.randomUUID().toString();
	Map<String, Object> map = new HashMap<String, Object>();
	final SalesOrder so = sos.getSalesOrder(Integer.parseInt(request.getParameter("invoice")));
	map.put("ORDER", so);
	session.getServletContext().setAttribute(tx, map); //this aint good - memory leak!


	String s = request.getParameter("failPDT");
	boolean failPDT = false;
	if(s != null && (s.equalsIgnoreCase("true") || s.equalsIgnoreCase("on"))){
		failPDT = true;
	}
	
	s = request.getParameter("failPDTStatus");
	boolean failPDTStatus = false;
	if(s != null && (s.equalsIgnoreCase("true") || s.equalsIgnoreCase("on"))){
		failPDTStatus = true;
	}

	s = request.getParameter("failIPN");
	boolean failIPN = false;
	if(s != null && (s.equalsIgnoreCase("true") || s.equalsIgnoreCase("on"))){
		failIPN = true;
	}

	s = request.getParameter("failIPNStatus");
	boolean b = false;
	if(s != null && (s.equalsIgnoreCase("true") || s.equalsIgnoreCase("on"))){
		b = true;
	}
	final boolean failIPNStatus = b;

	if(failPDT){
		map.put("pdt_return", "FAIL");
	}else{
		map.put("pdt_return", "SUCCESS");
	}
	if(failPDTStatus){
		map.put("pdt_st", "failed");
	}else{
		map.put("pdt_st", "pending");
	}
	if(failIPN){
		map.put("ipn_return", "INVALID");
	}else{
		map.put("ipn_return", "VERIFIED");
	}

	//only make IPN run, if PDT didnt fail. IPN is a second notification that a pending 
	//payment has been successful or not. if PDT determines that it already failed, IPN would
	//never make the callback.
	if(!failPDT && !failPDTStatus){
		Thread t = new Thread(new Runnable(){
			public void run() {
				
			    HttpClient client = new HttpClient();
			    PostMethod method = new PostMethod(ipnURL);
				try {
					//ipn calls are made some time after pdt...
					Thread.sleep(1000L);

					String ipnSt = "completed";
					if(failIPNStatus){
						ipnSt = "failed";
					}
					
					NameValuePair[] pairs = new NameValuePair[6];
					int i = 0;
					pairs[i++] = new NameValuePair("invoice", so.getUid().toString());
					pairs[i++] = new NameValuePair("tx", tx);
					pairs[i++] = new NameValuePair("receiver_email", so.getEmail());
					pairs[i++] = new NameValuePair("mc_gross", SalesOrderHelper.getGrandTotal(so).toString());
					pairs[i++] = new NameValuePair("payment_status", ipnSt);
					pairs[i++] = new NameValuePair("mc_shipping", so.getDeliveryTotal().toString());
					
					method.setQueryString(pairs);
					byte[] responseBody = null;
					int statusCode = -1;
					// execute the method.
					statusCode = client.executeMethod(method);
					responseBody = method.getResponseBody();
					String res = new String(responseBody);
					if (statusCode != 200) {
						System.err.println("Failed to call IPN at " + ipnURL + ". Code was: " + statusCode + ", Error was: " + res);
					}
				}catch(Exception e){
					//aint much else we can do. the response has already returned by this stage!
					e.printStackTrace();
				} finally {
					// release the connection.
					method.releaseConnection();
				}
			}
		});
		t.setName("ipnThread");
		t.start();
	}

	response.sendRedirect(returnURL + "?tx=" + tx + "&item_number=" + so.getUid());
	%>DONE<%
}catch(Throwable t){
	t.printStackTrace();
	%>
	FAILED: <%=t.getMessage() %>
	<%
}

%>
