<%
/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

%>
<%@page import="uk.co.maxant.gwtdemo.server.MailService"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.PaymentDetails"%>
<%@page import="uk.co.maxant.gwtdemo.server.ConfigService"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.ServiceLocator"%>
<%@page import="uk.co.maxant.gwtdemo.server.SalesOrderService"%>
<%@ page import="java.util.*" %>
<%@ page import="java.net.*" %>
<%@ page import="java.io.*" %>
<%@ page import="org.apache.log4j.Logger" %>
<%
SalesOrderService salesOrderService = ServiceLocator.getInstance().getSalesOrderService();
ConfigService configService = ServiceLocator.getInstance().getConfigService();
MailService mailService = ServiceLocator.getInstance().getMailService();
Logger log = Logger.getLogger(this.getClass());

Integer orderNum = null;
String invoice = request.getParameter("invoice");
String res = null;
try{
	if(invoice == null) throw new Exception("Failed to get the invoice number from PayPal IPN. Invoice number not present in the request.");
	try{
		orderNum = Integer.parseInt(invoice);
	}catch(NumberFormatException nfe){
		throw new Exception("Failed to parse the invoice number from PayPal IPN. Invoice number given was " + invoice);
	}

	//re-post to PayPal system and add 'cmd'
	Enumeration en = request.getParameterNames();
	String str = "cmd=_notify-validate";
	while(en.hasMoreElements()){
		String paramName = (String)en.nextElement();
		String paramValue = request.getParameter(paramName);
		str = str + "&" + paramName + "=" + URLEncoder.encode(paramValue, "UTF-8");
	}

	//post back to PayPal system to validate
	PrintWriter pw = null;
	BufferedReader in = null;
	try{
		URL u = new URL(configService.value(ConfigService.paypal_payment_url));
		URLConnection uc = u.openConnection();
		uc.setDoOutput(true);
		uc.setRequestProperty("Content-Type","application/x-www-form-urlencoded");
		pw = new PrintWriter(uc.getOutputStream());
		pw.println(str);
		pw.close();

		in = new BufferedReader(new InputStreamReader(uc.getInputStream()));
		StringBuffer sb = new StringBuffer();
		String curr = null;
		while((curr = in.readLine()) != null){
	sb.append(curr);
		}
		res = sb.toString().trim(); //for paypal stub its important to do this trim. for paypal, it shouldnt make a difference
		in.close();
	}finally{
		if(pw != null) pw.close();
		if(in != null) in.close();
	}

	PaymentDetails details = new PaymentDetails(request.getParameterMap(), orderNum);
	details.setSource("PayPal IPN");
	details.setPaymentType("paypal");

	try{
		if(details.getTxnType() != null && details.getTxnType().equals("new_case")){
	//if the txn_type = "new_case" then this is a dispute, in which case call OrderService.handleDispute()	
	salesOrderService.handleDispute(details);
		}else{
	salesOrderService.updatePaymentStatus(details);
		}
	}catch(Exception e){
		//something went wrong, so lets mark the order as needing attention
		String msg = "Failed to update payment status or handle dispute while receiving PayPal IPN notification. The technical error was: " + e.getMessage() + ". Check previous order history below, as there may be more information.";
		salesOrderService.markOrderAsNeedingAttention(orderNum, msg);
	}
	
	//check notification validation
	if(res == null) throw new Exception("Failed to get verification response for PayPal IPN for order " + orderNum);
	if(res.equals("VERIFIED")){
		//excellent - this is what we were hoping for
	}else if(res.equals("INVALID")){
		throw new Exception("Although payment details were updated while receiving PayPal IPN notification, the verification response from PayPal was invalid. This should be investigated with the payment authority and the help of maxAnt.");
	}else{
		throw new Exception("Although payment details were updated while receiving PayPal IPN notification, the verification response from PayPal was unknown. This should be investigated with the payment authority and the help of maxAnt.");
	}
%>SUCCESS<%
}catch(Throwable t){
	String mapDetails = "";
	Enumeration keys = request.getParameterNames();
	while(keys.hasMoreElements()){
		String key = (String)keys.nextElement();
		mapDetails += key + "\t\t\t\t" + request.getParameter(key) + "\r\n";
	}

	String msg = "Failed to process payment successfully for order (#" + orderNum + "). Investigate whether it has actually been paid for, and manually update the order to set the payment status so that the order can be processed. Parameters sent from PayPal IPN were:\r\n\r\n" + mapDetails + " and IPN response was:\r\n\r\n" + res;
	log(msg, t);
	try{
		salesOrderService.markOrderAsNeedingAttention(orderNum, msg);
	}catch(Exception e2){
		//TODO handle with a mail enabled error handler! otherwise no one will ever see this unless they are trawling logs
		msg = "Failed to mark order " + orderNum + " as needing attention. Please refer to the error above (timestamp " + System.currentTimeMillis() + ").\r\n\r\nFRQDD3922843E THIS ORDER STILL REQUIRES INVESTIGATING!\r\n\r\n";
		log(msg, t);
		mailService.sendMail(configService.value(ConfigService.emailAdmin), request.getContextPath() + " - Paypal IPN Error", msg);
		//if the mail cant be sent, then theres nowt we can do anyway and we already logged it with a special code which a log trawler could pick up...
	}
	%>ERROR<%
}

String mapDetails = "";
Enumeration keys = request.getParameterNames();
while(keys.hasMoreElements()){
	String key = (String)keys.nextElement();
	String value = request.getParameter(key);
	mapDetails += key + "\t\t" + value + "\r\n";
}
log.info("\r\n\r\nReceived IPN from PayPal:\r\n" + mapDetails + "\r\nResponse was:\r\n" + res + "\r\n\r\n");

%>
