/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


/**
 * disables all elements of a form just 
 * before submitting it back to the server.
 * also sets the cursor to hourglass.
 */
function disableAllForms() {
	setHourglassPointer();
	for(var i = 0; i < document.forms.length; i++){
		for(var j = 0; j < document.forms[i].elements.length; j++){
			if(document.forms[i].elements[j].type.toLowerCase() == 'submit'){
				//its a button, so change the text...
//				document.forms[i].elements[j].value = "Processing...";
			}
			//need to do this after a short time so that the event is posted back to .net! otherwise
			//the buttons event handler is not called
			window.setTimeout("document.forms[" + i + "].elements[" + j + "].disabled = true;", 50);
		}
	}
	return true;
}

/**
 * Set the cursor to an hour glass
 */
function setHourglassPointer() { 
	if (document.all) {
		for (var i=0;i < document.all.length; i++) {
			document.all(i).style.cursor = 'wait'; 
		}
	}
} 

/**
 * Set the cursor to the default cursor (a pointer)
 */
function resetPointer() { 
	if (document.all) {
		for (var i=0;i < document.all.length; i++) {
			document.all(i).style.cursor = 'default';
		}
	}
}

/**
 * Call this to simulate a click on the button if the key which is pressed is a return (13) key.
 * The buttonID should be a string like mainForm:submitButton - use the fully qualified name which JSF
 * assigns, not just the name in the ID tag.
 */
function submitIfReturn(buttonID){
	var keycode;
	var retVal = false;

	if (window.event) {
		keycode = window.event.keyCode;
	} else if (event) {
		keycode = event.which;
	} else {
		return true;
	}

	if (keycode == 13) { 
		document.getElementById(buttonID).click();
	} else {
		retVal = true;
	}

	return retVal;
}

function setOnClickToDisableFormOnAllHyperlinks() {
	for(var i = 0; i < document.anchors.length; i++){
		document.anchors[i].onclick = new Function('return disableAllForms();'); 
	}
	return true;
}

function trim(stringToTrim) {
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}

function ltrim(stringToTrim) {
	return stringToTrim.replace(/^\s+/,"");
}

function rtrim(stringToTrim) {
	return stringToTrim.replace(/\s+$/,"");
}
