<%
/*  
 * Copyright (c) 2009 Ant Kutschera, maxant
 * 
 * This file is part of the maxant GWT Demo.
 * 
 * maxant GWT Demo is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant GWT Demo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

%>
<%@page import="uk.co.maxant.gwtdemo.client.shop.ui.Shop"%>
<%@page import="uk.co.maxant.gwtdemo.server.po.Party"%>
<%@page import="uk.co.maxant.gwtdemo.server.PartyService"%>
<%@page import="uk.co.maxant.gwtdemo.server.po.Design"%>
<%@page import="uk.co.maxant.gwtdemo.server.DesignService"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.LogHelper"%>
<%@page import="org.apache.log4j.Logger"%>
<%@page import="com.sun.image.codec.jpeg.JPEGEncodeParam"%>
<%@page import="com.sun.image.codec.jpeg.JPEGImageEncoder"%>
<%@page import="com.sun.image.codec.jpeg.JPEGCodec"%>
<%@page import="java.awt.RenderingHints"%>
<%@page import="java.awt.Graphics2D"%>
<%@page import="java.awt.image.BufferedImage"%>
<%@page import="java.awt.Container"%>
<%@page import="java.awt.MediaTracker"%>
<%@page import="javax.swing.ImageIcon"%>
<%@page import="java.awt.Image"%>
<%@page import="java.io.FileInputStream"%>
<%@page import="java.io.BufferedInputStream"%>
<%@page import="java.io.ByteArrayOutputStream"%>
<%@page import="java.io.BufferedOutputStream"%>
<%@page import="java.io.FileOutputStream"%>
<%@page import="java.io.InputStream"%>
<%@page import="uk.co.maxant.gwtdemo.client.ApplicationException"%>
<%@page import="uk.co.maxant.gwtdemo.server.util.ServiceLocator"%>
<%@page import="java.io.IOException"%>
<%@page import="org.apache.tools.ant.util.FileUtils"%>
<%@page import="java.io.File"%>
<%@page import="uk.co.maxant.gwtdemo.client.Roles"%>
<%@page import="org.apache.commons.fileupload.FileItem"%>
<%@page import="org.apache.commons.fileupload.servlet.ServletFileUpload"%>
<%@page import="org.apache.commons.fileupload.disk.DiskFileItemFactory"%>
<%@page import="org.apache.commons.fileupload.FileItemFactory"%>
<%@page import="java.util.List"%>
<%@page import="org.apache.commons.fileupload.FileUploadBase.SizeLimitExceededException"%>
<%
Logger log = LogHelper.getLog();
boolean ok = false;
if(!request.isUserInRole(Roles.BACKOFFICE)){
	//not right role - refuse entry!
	%>BACKOFFICE role is required to update design images. DESUP001<%
}else{
	final int MAX_SIZE_BYTES = 5*1024*1024; //5 meg

	String type = null;
	String designUid = null;
	File temp = null;
	try{
		temp = File.createTempFile("designUpload", ".tmp", new File("../temp"));
		FileItemFactory factory = new DiskFileItemFactory(0, new File("../temp"));
		ServletFileUpload upload = new ServletFileUpload(factory);
		upload.setSizeMax(MAX_SIZE_BYTES);
		for(FileItem item : (List<FileItem>)upload.parseRequest(request)){
			if (item.isFormField()) {
				String name = item.getFieldName();
			    String value = item.getString();
			    if(name.equals("designUid")){
			    	designUid = value;
			    }
			} else {
				String fieldName = item.getFieldName();
				if(fieldName.equals("data")){
					int idx = item.getName().lastIndexOf(".");
					if(idx == -1 || idx + 1 > item.getName().length()){
						throw new ApplicationException("DESUP002", "", "Input file type cannot be determined. File extension MUST have only three letters.");
					}
					type = item.getName().substring(idx+1, item.getName().length()).toLowerCase();
					if(type.length() != 3 || !type.equalsIgnoreCase("jpg")){
						throw new ApplicationException("DESUP003", "", "Input file type MUST be a JPEG. File extension MUST have only three letters.");
					}
					item.write(temp);
				}
			}
		}
		
		//ok, lets write the design image now:
		String filename = session.getServletContext().getRealPath("index.jsp");
		String hiResFilename = filename;
		String filename1 = filename.substring(0, filename.length()-9) + "images/designs/design_small_" + designUid + ".jpg";
		String filename2 = filename.substring(0, filename.length()-9) + "images/designs/design_" + designUid + ".jpg";
		String filename3 = filename.substring(0, filename.length()-9) + "images/designs/design_large_" + designUid + ".jpg";
		hiResFilename = hiResFilename.substring(0, hiResFilename.length()-9) + "hiresimages/designs/design_large_" + designUid + ".jpg";
		File[] target = new File[]{new File(filename1), new File(filename2), new File(filename3)};
		File hiResTarget = new File(hiResFilename);

		boolean writeIt = false;
		for(int i = 0; i < target.length; i++){
			if(target[i].exists()){
				if(target[i].delete()){
					writeIt = true;
				}else{
					%>Unable to delete existing file. Seek advice from an administrator. DESUP004-<%=i %>.<%
					writeIt = false;
					break;
				}
			}else{
				//original doesnt exist, for some bizarre reason...
				writeIt = true;
			}
		}

		if(writeIt && hiResTarget != null){
			writeIt = false;
			if(hiResTarget.exists()){
				if(hiResTarget.delete()){
					writeIt = true;
				}else{
					%>Unable to delete existing high resolution file. Seek advice from an administrator. DESUP005.<%
				}
			}else{
				//original doesnt exist, for some bizarre reason...
				writeIt = true;
			}
		}
		
		if(writeIt){
			
			if(hiResTarget != null){
				if(!temp.renameTo(hiResTarget)){
					throw new ApplicationException("DESUP010", "", "Unable to move upload to hires original. Seek advice from an administrator.");
				}else{
					temp = null; //no need to delete it afterwards.
				}
			}

			//and now resize...

			long start = System.currentTimeMillis();
			InputStream in = null;
	        FileOutputStream fos = null;
	        BufferedOutputStream bos = null;
	        ByteArrayOutputStream baos = null;
			try{
	            baos = new ByteArrayOutputStream();
	            bos = new BufferedOutputStream(baos);
	            if(hiResTarget == null){
		            in = new BufferedInputStream(new FileInputStream(temp));
	            }else{
		            in = new BufferedInputStream(new FileInputStream(hiResTarget));
	            }
	            int current = -1;
	            while ((current = in.read()) != -1){
	                bos.write(current);
	            }
	            bos.flush();
	            bos.close();
	            bos = null;

	            //resize, twice
	            int[] widths = new int[]{	Shop.DESIGN_IMAGE_SIZE_WIDTH, 
		            						Shop.DESIGN_VIEWER_IMAGE_SIZE_WIDTH,
		            						Shop.DESIGN_ZOOM_IMAGE_SIZE_WIDTH};
	            
	            for(int i = 0; i < widths.length; i++){
		            Image image = new ImageIcon(baos.toByteArray()).getImage();
		            MediaTracker mediaTracker = new MediaTracker(new Container());
		            mediaTracker.addImage(image, 0);
		            mediaTracker.waitForID(0);
	
		            // determine thumbnail size from WIDTH and HEIGHT
		            int imageWidth = image.getWidth(null);
		            int imageHeight = image.getHeight(null);
		            double imageRatio = (double)imageWidth / (double)imageHeight;
		            int newHeight = (int)(widths[i] / imageRatio);
		            // draw original image to thumbnail image object and
		            // scale it to the new size on-the-fly
		            BufferedImage thumbImage = new BufferedImage(widths[i], newHeight, BufferedImage.TYPE_INT_RGB);
		            Graphics2D graphics2D = thumbImage.createGraphics();
		            graphics2D.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
		            graphics2D.drawImage(image, 0, 0, widths[i], newHeight, null);
		            fos = new FileOutputStream(target[i]);
		            bos = new BufferedOutputStream(fos);
		            JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(bos);
		            JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam(thumbImage);
		            param.setQuality(75.0f, false); //0-100% 
		            encoder.setJPEGEncodeParam(param);
		            encoder.encode(thumbImage);
	
		            bos.flush();
	            	bos.close(); bos = null;
	            	fos.close(); fos = null;
	            }
				log.info("Resized design image " + widths.length + " times in " + (System.currentTimeMillis()-start) + "ms.");

				ok = true;

			}catch(IOException e){
				throw new ApplicationException("DESUP007", "", "Could not resize image: " + e.getMessage());
			}finally{
	            if(in != null) in.close();
	            if(bos != null) {
	            	bos.flush();
	            	bos.close();
	            }
	            if(fos != null) fos.close();
	            if(baos != null) baos.close();
			}
		}
	}catch(SizeLimitExceededException e){
		%>File too large. Maximum file size is <%=MAX_SIZE_BYTES%> bytes.<br><br>DESUP006<br><br><%=e.getMessage()%><%
	}catch(ApplicationException e){
		%><%=e.getMessage() + "<br>" + e.getCode()%><%
	}catch(Exception e){
		%>An error occurred.<br><br><%=e.getMessage()%><br><br>DESUP008<%
	}finally{
		if(temp != null){
			try{
				temp.delete();
			}catch(Exception e){
				String appName = session.getServletContext().getServletContextName();
				String description = "Failed to delte temporary file after a failed design image upload. this file should be deleted manually. The file was: " + temp.getAbsolutePath();
				ServiceLocator.getInstance().getErrorService().reportError(appName, description, e);
			}
		}
	}
}
if(ok){
	%>OK<%
}
%>
